﻿; SQB v0.26x c2017..2019 ejn
; pb5.70LTS x64
;
; - manage and modify (squeebox) related playlists
;
#sqb_name = "SQB"                                                   ; program name
#sqb_version = "v0.26x"                                             ; version number
#sqb_copyright = "c2017..2019 EJN"                                  ; copyright notice
;
EnableExplicit
IncludeFile("..\x_lib\x_lib.pb")
x_init()
Declare init()
Declare main()
Declare loadsettings()
init()
main()
x_end()
;

Procedure history()
  ;
  ; to do
  ;
  ; - nothing for now
  ;
  ; known bugs
  ;
  ; - screen update / event handling is messy, would need a callback and some major rewriting, not sure if it is worth the effort
  ; - sometimes malformed entries in a playlist may show up when files are found missing during a scan, no clue why
  ;
  ; v0.26x
  ;
  ; - renamed reload to refresh
  ; - create a favorites.m3u file upon refresh, if possible
  ;
  ; v0.24x
  ;
  ; - sometimes playlist would contain strange html entries like %20 etcetera, added x_stringtostring() mode 18 to strip / convert those characters / lines
  ;
  ; v0.23x
  ;
  ; - use multiple instances of sox
  ; - hide sox
  ; - bugfix replace point
  ; - updated status window
  ; - some other bugfixes
  ;
  ; v0.21x
  ;
  ; - added hide-sox window option
  ; - added abort option to export folders and export playlists
  ;
  ; v0.15x
  ;
  ; - fixed bug in duplicate removal
  ; - returned proper functionality to the 'mark' button
  ;
  ; v0.13x
  ;
  ; - fixed bug in duplicate removal of missing files
  ; - fixed bug causing crash when no files were missing
  ;
  ; v0.11x
  ;
  ; - bugfix missing files scan
  ; - mix function
  ; - added auto reload
  ; - added some documentation
  ; - lists playlists missing files
  ; - added shuffle mode With dispersion And cluster suppression
  ; - default Ansi ON, ran into some issues with UTF8 with LMS messing up playlist order and dropping first line
  ;
  ; v0.08x
  ;
  ; - very minor changes
  ; - updated documentation
  ;
  ; v0.07x
  ;
  ; - added export of complete folders without using playlists
  ; - added manual
  ;
  ; v0.06x
  ;
  ; - added overwrite option to export (to speed up exports when destination already exist)
  ; - added prefix option (easier identify exported playlists in a list of regular folders)
  ; - added temp folder option (only needed in very rare occaisions where sox could not handle a passed unc(?) unicode(?) path)
  ; - added check on missing backslashes in path names
  ; - some cleaner code
  ; - fixed some english typos
  ; - better icon
  ;
  ; v0.05x
  ;
  ; - different icon
  ; - info sometimes did not update screen
  ;
  ; v0.04x
  ;
  ; - export
  ; - convert during export
  ;
  ; v0.03x
  ;
  ; - sox parameters
  ; - filehandling failed sometimes on a server, added x_ex... versions for readfile() createfile() and copyfile()
  ; - added valid path check to replacepoint_path when pointing to a new music file
  ; - added sort option
  ; - added 'skipped' to info panel
  ; - added protection against crashes caused by files on a server that won't open
  ;
  ; v0.02x
  ;
  ; replace module complete
  ;
  ; v0.01x
  ;
  ; - initial version
  ;
EndProcedure

Procedure init()
  Protected f.s
  ;
  ; *** initialize all constants and variables, load (standard) gui images and icons
  ;
  Enumeration
    ;
    ; *** windows
    ;
    #w_main_nr
    ;
    ; *** menus
    ;
    ; *** toolbars
    ;
    ; *** gadgets
    ;
    ; generic gadget
    ;
    #g_progress
    ;
    ; main panel
    ;
    #g_panel_main
    ;
    #g_prefs_description
    #g_prefs_frame_paths
    #g_prefs_playlist_txt
    #g_prefs_playlist_path
    #g_prefs_playlist_browse
    #g_prefs_playlist_explore
    #g_prefs_favorites_txt
    #g_prefs_favorites_file
    #g_prefs_favorites_browse
    #g_prefs_music_txt
    #g_prefs_music_path
    #g_prefs_music_browse
    #g_prefs_music_explore
    #g_prefs_server_txt
    #g_prefs_server_path
    #g_prefs_server_browse
    #g_prefs_uselmspaths_toggle
    #g_prefs_uselmspaths_txt
    #g_prefs_refresh_toggle
    #g_prefs_refresh_txt
    #g_prefs_runningonserver_toggle
    #g_prefs_runningonserver_txt
    #g_prefs_frame_playlists
    #g_prefs_forceascii_toggle
    #g_prefs_forceascii_txt
    #g_prefs_warnings_toggle
    #g_prefs_warnings_txt
    #g_prefs_quircklevel_txt
    #g_prefs_quircklevel_combo
    #g_prefs_explorerlaunch_txt
    #g_prefs_explorerlaunch_path
    #g_prefs_explorerlaunch_browse
    #g_prefs_editorlaunch_txt
    #g_prefs_editorlaunch_path
    #g_prefs_editorlaunch_browse
    #g_prefs_exe_txt
    #g_prefs_exe_path
    #g_prefs_exe_browse
    #g_prefs_hidesox_txt
    #g_prefs_hidesox_toggle
    #g_prefs_jobsmax_txt
    #g_prefs_jobsmax_combo
    #g_prefs_bitrate_txt
    #g_prefs_bitrate_combo
    #g_prefs_quality_txt
    #g_prefs_quality_combo
    #g_prefs_exportasmp3_toggle
    #g_prefs_exportasmp3_txt
    #g_prefs_frame_exportplaylists
    #g_prefs_exportnumbers_toggle
    #g_prefs_exportnumbers_txt
    #g_prefs_exportoverwrite_toggle
    #g_prefs_exportoverwrite_txt
    #g_prefs_exportusetemp_toggle
    #g_prefs_exportusetemp_txt
    #g_prefs_exportfolders_toggle
    #g_prefs_exportfolders_txt
    #g_prefs_exportprefix_toggle
    #g_prefs_exportprefix_txt
    #g_prefs_export_txt
    #g_prefs_export_path
    #g_prefs_export_browse
    #g_prefs_help
    #g_prefs_load
    #g_prefs_save
    ;
    #g_folder_description
    #g_folder_led
    #g_folder_table
    #g_folder_read
    #g_folder_explore
    #g_folder_export
    ;
    #g_playlist_description
    #g_playlist_led
    #g_playlist_table
    #g_playlist_read
    #g_playlist_explore
    #g_playlist_edit
    #g_playlist_strip
    #g_playlist_sort
    #g_playlist_mark
    #g_playlist_dedupe
    #g_playlist_shuffle
    #g_playlist_mix
    #g_playlist_replace
    #g_playlist_export
    ;
    #g_missing_description
    #g_missing_led
    #g_missing_list
    #g_missing_uselmspaths_toggle
    #g_missing_uselmspaths_txt
    #g_missing_run
    #g_missing_copy
    ;
    #g_replace_description
    #g_replace_list
    #g_replace_existcheck_toggle
    #g_replace_existcheck_txt
    #g_replace_pointremember_toggle
    #g_replace_pointremember_txt
    #g_replace_clear
    #g_replace_applyplus
    #g_replace_point
    #g_replace_apply
    ;
    #g_formats_description
    #g_formats_led
    #g_formats_table
    #g_formats_run
    ;
    #g_information_description
    #g_information_led
    #g_information_list
    #g_information_run
    ;
    ; report panel
    ;
    #g_panel_transcopy
    ;
    #g_transcopy_description
    #g_transcopy_led
    #g_transcopy_table
    #g_transcopy_abort
    ;
  EndEnumeration
  ;
  ; *** images
  ;
  Enumeration
    #i_led_red
    #i_led_green
    #i_led_white
    #i_led_yellow
  EndEnumeration
  ;
  DataSection
    i_led_red:
    IncludeBinary("icons\led_red.ico")
    i_led_green:
    IncludeBinary("icons\led_green.ico")
    i_led_white:
    IncludeBinary("icons\led_white.ico")
    i_led_yellow:
    IncludeBinary("icons\led_yellow.ico")
  EndDataSection
  ;
  Global i_led_red_h       = CatchImage(#i_led_red,      ?i_led_red)
  Global i_led_green_h     = CatchImage(#i_led_green,    ?i_led_green)
  Global i_led_white_h     = CatchImage(#i_led_white,    ?i_led_white)
  Global i_led_yellow_h    = CatchImage(#i_led_yellow,   ?i_led_yellow)
  ;
  ; *** actions / menus / toolbarbuttons
  ;
  Enumeration
    #f_none
    #f_exit
  EndEnumeration
  ;
  Enumeration 60000
    #f_point
  EndEnumeration
  ;
  Enumeration
    #g_panel_prefs
    #g_panel_folder
    #g_panel_playlist
    #g_panel_missing
    #g_panel_replace
    #g_panel_formats
    #g_panel_information
    #g_panel_help
  EndEnumeration
  ;
  ; *** global variables and constants related to event loop, windows, gadgets etc.
  ;
  Global g_panel_h.i
  Global w_main_h.i
  ;
  Global event.i
  Global event_type.i
  Global event_menu.i
  Global event_gadget.i
  Global refresh.i
  Global action.i
  ;
  Global w_main_width.i         = 700
  Global w_main_height.i        = 400
  ;
  ; *** conversion instances
  ;
  Global NewList jobs_id.i()
  Global jobs_n.i
  Global abort.i
  ;
  ; *** other global vars
  ;
  ; default settings are set in loadsettings()
  ;
  Global music_path.s                                                           ; squeezebutt's path to the music files
  Global playlist_path.s                                                        ; squeezebutt's path to the playlists
  Global favorites_file.s                                                       ; path to favorites.oml file
  Global server_path.s                                                          ; lms's path to the music files
  Global runningonserver.i                                                      ; true if squeezebut is running on the server
  Global uselmspaths.i                                                          ; show lmspaths instead of local paths
  Global explorerlaunch_file.s                                                  ; explorer to start
  Global editorlaunch_file.s                                                    ; editor to start
  Global forceascii.i                                                           ; set to #true to enforce ascii .m3u files (strip bom header)
  Global warnings.i                                                             ; set to #true to show warnings before modifying files and results after modifying
  Global quircklevel.i
  Global reload.i                                                               ; set to #true to automatically refresh list contents on resize and tab change
  Global sox_file.s                                                             ; where to find sox
  Global exportasmp3.i                                                          ; convert any non-mp3 to mp3 using sox
  Global conversionquality.i                                                    ; mp3 conversion quality
  Global mp3bitrate.s                                                           ; encoding type and bitrate
  Global exportfolders.i                                                        ; keep folder structure when exporting
  Global exportnumber                                                           ; add numbering
  Global exportoverwrite.i                                                      ; overwrite existing files
  Global exportusetemp.i                                                        ; use temporary local folder for conversion .flac to .mp3
  Global exportprefix.i                                                         ; insert 'playlist - ' prefix to foldername
  Global export_path.s                                                          ; path used to export music files
  Global replacecheck.i                                                         ; check if new path+file exists before modifying playlist
  Global replacelist_row.i                                                      ; what row is the cursor currently on in the replacelist
  Global replacelist.s                                                          ; default replace list
  Global skipped.i                                                              ; number of files that would not open so were skipped
  Global pointremember.i                                                        ; remember last file / folder pointed to
  Global hidesox.i                                                              ; keep sox conversion window in the background
  Global jobsmax.i                                                              ; max number of jobs
  ;
  ; *** load .cfg settings
  ;
  loadsettings()                                                                ; to set default values
  ;
  ; *** other globals or changes
  ;
  Global replacepoint_path.s    = music_path                                    ; last point searched
  ;
  ; *** help text
  ;
  DataSection
    helptext:
    IncludeBinary("sqb.txt")
    Data.b 0, 0
  EndDataSection
  Global p_helptext = ?helptext
  ;
EndProcedure

Procedure draw()
  Protected w.i, h.i, x.i, xx.i, y.i, d.i, t.s, n.i
  ;
  ; called every time the window is resized
  ; not very elegant but hey, it works :-)
  ;
  w_main_width = WindowWidth(#w_main_nr)
  w_main_height = WindowHeight(#w_main_nr)
  ;
  ProgressBarGadget(#g_progress,0,w_main_height-5,w_main_width,5,0,1000)
  ;
  PanelGadget(#g_panel_main,8,8,w_main_width-15,w_main_height-15)
    ;
    ; *** preferences panel
    ;
    AddGadgetItem(#g_panel_main,-1,"Preferences")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    TextGadget(#g_prefs_description,x,y,w,20,"Settings and paths used by this program and LMS.")
    y = y+25
    FrameGadget(#g_prefs_frame_paths,x,y,w,210,"Paths")
    y = y+25
    x = x+16
    TextGadget(#g_prefs_explorerlaunch_txt,x,y+2,70,20,"Explorer")
    StringGadget(#g_prefs_explorerlaunch_path,x+80,y,w-x-116,20,"")
    GadgetToolTip(#g_prefs_explorerlaunch_path,"Choose default explorer or file manager. Leave empty to use Windows Explorer.")
    ButtonGadget(#g_prefs_explorerlaunch_browse,x+w-56,y,30,20,"..")
    y = y+25
    TextGadget(#g_prefs_editorlaunch_txt,x,y+2,70,20,"Editor")
    StringGadget(#g_prefs_editorlaunch_path,x+80,y,w-x-116,20,"")
    GadgetToolTip(#g_prefs_editorlaunch_path,"Choose default editor. Leave empty to use Windows Notepad.")
    ButtonGadget(#g_prefs_editorlaunch_browse,x+w-56,y,30,20,"..")
    y = y+25
    TextGadget(#g_prefs_music_txt,x,y+2,70,20,"Music path")
    StringGadget(#g_prefs_music_path,x+80,y,w-x-184,20,"")
    GadgetToolTip(#g_prefs_music_path,"The path SQB uses to access your songs, ie. the path to your songs from the computer SQB is running on, for example \\server\music\songs")
    ButtonGadget(#g_prefs_music_browse,x+w-124,y,30,20,"..")
    ButtonGadget(#g_prefs_music_explore,x+w-86,y,60,20,"Explore")
    y = y+25
    TextGadget(#g_prefs_playlist_txt,x,y+2,70,20,"Playlist path")
    StringGadget(#g_prefs_playlist_path,x+80,y,w-x-184,20,"")
    GadgetToolTip(#g_prefs_playlist_path,"The path SQB uses to access your playlists, ie. the path to your playlists from the computer SQB is running on, for example \\server\music\playlists")
    ButtonGadget(#g_prefs_playlist_browse,x+w-124,y,30,20,"..")
    ButtonGadget(#g_prefs_playlist_explore,x+w-86,y,60,20,"Explore")
    y = y+25
    TextGadget(#g_prefs_favorites_txt,x,y+2,70,20,"Favorites file")
    StringGadget(#g_prefs_favorites_file,x+80,y,w-x-116,20,"")
    GadgetToolTip(#g_prefs_favorites_file,"Complete path to the favorites.oml file, which is used by LMS to store the favorites, for example \\sever\drive_c\programdata\squeezebox\prefs\favorites.opml")
    ButtonGadget(#g_prefs_favorites_browse,x+w-56,y,30,20,"..")
    y = y+30
    CheckBoxGadget(#g_prefs_runningonserver_toggle,x,y,16,16,"")
    TextGadget(#g_prefs_runningonserver_txt,x+20,y,100,20,"Running on host")
    GadgetToolTip(#g_prefs_runningonserver_toggle,"SQB is running on the same machine as LMS, or playlists are stored locally.")
    x = x+125
    CheckBoxGadget(#g_prefs_uselmspaths_toggle,x,y,16,16,"")
    TextGadget(#g_prefs_uselmspaths_txt,x+20,y,100,20,"Use LMS paths")
    GadgetToolTip(#g_prefs_uselmspaths_toggle,"Show paths from LMS perspective instead of SQB perspective.")
    x = x+115
    CheckBoxGadget(#g_prefs_refresh_toggle,x,y,16,16,"")
    TextGadget(#g_prefs_refresh_txt,x+20,y,100,20,"Auto refresh")
    GadgetToolTip(#g_prefs_refresh_toggle,"Auto refresh on tab change or window resize.")
    x = x-240
    y = y+25
    TextGadget(#g_prefs_server_txt,x,y+2,70,20,"LMS path")
    StringGadget(#g_prefs_server_path,x+80,y,w-116-x,20,"")
    GadgetToolTip(#g_prefs_server_path,"The path LMS uses to access your music. You can find this path on the Logitech Media Server / Basic Settings / Media Folders.")
    x = x-16
    y = y+40
    FrameGadget(#g_prefs_frame_playlists,x,y,w,55,"Playlists && Replace")
    y = y+25
    x = x+16
    CheckBoxGadget(#g_prefs_forceascii_toggle,x,y,16,16,"")
    TextGadget(#g_prefs_forceascii_txt,x+20,y,300,20,"Use Ansi instead of UTF8")
    GadgetToolTip(#g_prefs_forceascii_toggle,"Remove BOM and only support Ansi (Ascii) characterset. Leave ON.")
    x = x+160
    CheckBoxGadget(#g_prefs_warnings_toggle,x,y,16,16,"")
    TextGadget(#g_prefs_warnings_txt,x+20,y,300,20,"Show warnings and results")
    GadgetToolTip(#g_prefs_warnings_toggle,"Show warnings before and results after modifying playlists.")
    x = x+170
    TextGadget(#g_prefs_quircklevel_txt,x,y,80,20,"Quirck mix level")
    ComboBoxGadget(#g_prefs_quircklevel_combo,x+85,y-3,50,20)
    GadgetToolTip(#g_prefs_quircklevel_combo,"Quirck level, 0 = none, 10 = reality shattering. Please consult a reputable scientist before modifying.")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"0")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"1")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"2")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"3")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"4")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"5")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"6")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"7")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"8")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"9")
    AddGadgetItem(#g_prefs_quircklevel_combo,-1,"10")
    x = x-346
    y = y+40
    FrameGadget(#g_prefs_frame_exportplaylists,x,y,w,55+25+30,"Export && Conversion")
    y = y+25
    x = x+16
    TextGadget(#g_prefs_export_txt,x,y+2,70,20,"Export path")
    StringGadget(#g_prefs_export_path,x+80,y,w-x-116,20,"")
    GadgetToolTip(#g_prefs_export_path,"Location to copy exported files to.")
    ButtonGadget(#g_prefs_export_browse,x+w-56,y,30,20,"..")
    y = y+30
    CheckBoxGadget(#g_prefs_exportfolders_toggle,x,y,16,16,"")
    TextGadget(#g_prefs_exportfolders_txt,x+20,y,200,20,"Use subfolders")
    GadgetToolTip(#g_prefs_exportfolders_toggle,"Maintain folder structure relative to original. No check on duplicate filenames when switched off.")
    CheckBoxGadget(#g_prefs_exportprefix_toggle,x+110,y,16,16,"")
    TextGadget(#g_prefs_exportprefix_txt,x+130,y,300,20,"Prefix")
    GadgetToolTip(#g_prefs_exportprefix_toggle,"Preceed each playlist folder with a 'playlist' tag.")
    CheckBoxGadget(#g_prefs_exportnumbers_toggle,x+180,y,16,16,"")
    TextGadget(#g_prefs_exportnumbers_txt,x+200,y,300,20,"Number")
    GadgetToolTip(#g_prefs_exportnumbers_toggle,"Preceed each file with a number (using sequence in playlist).")
    CheckBoxGadget(#g_prefs_exportoverwrite_toggle,x+260,y,16,16,"")
    TextGadget(#g_prefs_exportoverwrite_txt,x+280,y,200,20,"Overwrite")
    GadgetToolTip(#g_prefs_exportoverwrite_toggle,"Overwrite exsiting files.")
    CheckBoxGadget(#g_prefs_exportasmp3_toggle,x+350,y,16,16,"")
    TextGadget(#g_prefs_exportasmp3_txt,x+370,y,100,20,"To MP3")
    GadgetToolTip(#g_prefs_exportasmp3_toggle,"Convert all .flac to .mp3 when exporting. Leave MP3's alone (copy only). Requires Sox.")
    CheckBoxGadget(#g_prefs_exportusetemp_toggle,x+435,y,16,16,"")
    TextGadget(#g_prefs_exportusetemp_txt,x+455,y,100,20,"Use temp")
    GadgetToolTip(#g_prefs_exportusetemp_toggle,"Use local temporary folder for conversions. Currently not used.")
    DisableGadget(#g_prefs_exportusetemp_toggle,1)
    CheckBoxGadget(#g_prefs_hidesox_toggle,x+520,y,16,16,"")
    TextGadget(#g_prefs_hidesox_txt,x+540,y,100,20,"Hide Sox")
    GadgetToolTip(#g_prefs_hidesox_toggle,"Keep Sox window hidden.")
    TextGadget(#g_prefs_jobsmax_txt,x+600,y,45,20,"Instances")
    ComboBoxGadget(#g_prefs_jobsmax_combo,x+655,y-3,50,20)
    GadgetToolTip(#g_prefs_jobsmax_combo,"Number of conversion instances")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"1")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"2")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"3")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"4")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"5")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"6")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"7")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"8")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"9")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"10")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"11")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"12")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"13")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"14")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"15")
    AddGadgetItem(#g_prefs_jobsmax_combo,-1,"16")
    TextGadget(#g_prefs_bitrate_txt,x+725,y,40,20,"Bitrate")
    ComboBoxGadget(#g_prefs_bitrate_combo,x+760,y-3,70,20)
    GadgetToolTip(#g_prefs_bitrate_combo,"Bitrate, CBR 320 = best, VBR 0 = best. Most people cannot hear the difference between MP3 CBR320 and FLAC.")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"CBR 320")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"CBR 256")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"CBR 224")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"CBR 192")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"CBR 160")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"CBR 128")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 0")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 1")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 2")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 3")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 4")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 5")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 6")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 7")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 8")
    AddGadgetItem(#g_prefs_bitrate_combo,-1,"VBR 9")
    TextGadget(#g_prefs_quality_txt,875,y,40,20,"Quality")
    ComboBoxGadget(#g_prefs_quality_combo,x+895,y-3,50,20)
    GadgetToolTip(#g_prefs_quality_combo,"Conversion quality, 0 = best, 9 = fastest conversion.")
    AddGadgetItem(#g_prefs_quality_combo,-1,"0")
    AddGadgetItem(#g_prefs_quality_combo,-1,"1")
    AddGadgetItem(#g_prefs_quality_combo,-1,"2")
    AddGadgetItem(#g_prefs_quality_combo,-1,"3")
    AddGadgetItem(#g_prefs_quality_combo,-1,"4")
    AddGadgetItem(#g_prefs_quality_combo,-1,"5")
    AddGadgetItem(#g_prefs_quality_combo,-1,"6")
    AddGadgetItem(#g_prefs_quality_combo,-1,"7")
    AddGadgetItem(#g_prefs_quality_combo,-1,"8")
    AddGadgetItem(#g_prefs_quality_combo,-1,"9")
    y = y+25
    TextGadget(#g_prefs_exe_txt,x,y+3,70,20,"Sox")
    StringGadget(#g_prefs_exe_path,x+80,y,w-x-116,20,"")
    GadgetToolTip(#g_prefs_exe_path,"The path to sox.exe. Place all associated DLL's in this folder.")
    ButtonGadget(#g_prefs_exe_browse,x+w-56,y,30,20,"..")
    x = x-16
    y = h-15
    xx = x+w-60-2*63
    ButtonGadget(#g_prefs_help,xx,y,60,24,"Help")
    GadgetToolTip(#g_prefs_help,"Show instructions and license.")
    xx = xx+63
    ButtonGadget(#g_prefs_load,xx,y,60,24,"Load")
    GadgetToolTip(#g_prefs_load,"Load last saved settings. If SQB.cfg is missing, then load defaults.")
    xx = xx+63
    ButtonGadget(#g_prefs_save,xx,y,60,24,"Save")
    GadgetToolTip(#g_prefs_save,"Save settings. Will be auto-loaded on restart.")
    ;
    ; *** folder panel
    ;
    AddGadgetItem(#g_panel_main,-1,"Folders")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    ImageGadget(#g_folder_led,x+w-18,y,16,16,i_led_white_h)
    TextGadget(#g_folder_description,x,y,w-30,20,"Select one or more folders to export.")
    y = y+25
    ListViewGadget(#g_folder_table,x,y,w,h-58,#PB_ListView_MultiSelect)
    y = h-15
    xx = x+w-60-2*63
    ButtonGadget(#g_folder_read,xx,y,60,24,"Refresh")
    GadgetToolTip(#g_folder_read,"(Re)read folders")
    xx = xx+63
    ButtonGadget(#g_folder_explore,xx,y,60,24,"Explore")
    GadgetToolTip(#g_folder_explore,"Browse first selected folder")
    xx = xx+63
    ButtonGadget(#g_folder_export,xx,y,60,24,"Export")
    GadgetToolTip(#g_folder_export,"Export all marked folders")
    ;
    ; *** playlist panel
    ;
    AddGadgetItem(#g_panel_main,-1,"Playlists")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    ImageGadget(#g_playlist_led,x+w-18,y,16,16,i_led_white_h)
    TextGadget(#g_playlist_description,x,y,w-30,20,"Modify specific playlist. Doubleclick to edit. Note that playlists are only reprocessed by LMS upon 'clear library and full rescan'.")
    y = y+25
    ListViewGadget(#g_playlist_table,x,y,w,h-58)
    y = h-15
    xx = x+w-60-10*63
    ButtonGadget(#g_playlist_read,xx,y,60,24,"Refresh")
    GadgetToolTip(#g_playlist_read,"(Re)read playlist folder")
    xx = xx+63
    ButtonGadget(#g_playlist_explore,xx,y,60,24,"Explore")
    GadgetToolTip(#g_playlist_explore,"Browse playlist folder")
    xx = xx+63
    ButtonGadget(#g_playlist_edit,xx,y,60,24,"Edit")
    GadgetToolTip(#g_playlist_edit,"Edit playlist")
    xx = xx+63
    ButtonGadget(#g_playlist_strip,xx,y,60,24,"Strip")
    GadgetToolTip(#g_playlist_strip,"Remove all # lines from playlist, except #MISSING.")
    xx = xx+63
    ButtonGadget(#g_playlist_sort,xx,y,60,24,"Sort")
    GadgetToolTip(#g_playlist_sort,"Remove all # lines from playlist except for #MISSING, then sort.")
    xx = xx+63
    ButtonGadget(#g_playlist_mark,xx,y,60,24,"Mark")
    GadgetToolTip(#g_playlist_mark,"Remove all # lines from playlist, mark all files missing with #MISSING.")
    xx = xx+63
    ButtonGadget(#g_playlist_shuffle,xx,y,60,24,"Shuffle")
    GadgetToolTip(#g_playlist_shuffle,"Sort then shuffle the playlist.")
    xx = xx+63
    ButtonGadget(#g_playlist_dedupe,xx,y,60,24,"Dedupe")
    GadgetToolTip(#g_playlist_dedupe,"Sort playlist, remove all duplicate entries, mark missing files.")
    xx = xx+63
    ButtonGadget(#g_playlist_mix,xx,y,60,24,"Mix")
    GadgetToolTip(#g_playlist_mix,"Create new playlist by combining two other playlists.")
    xx = xx+63
    ButtonGadget(#g_playlist_replace,xx,y,60,24,"Replace")
    GadgetToolTip(#g_playlist_replace,"Modify playlist using the settings from the 'Replace' tab.")
    xx = xx+63
    ButtonGadget(#g_playlist_export,xx,y,60,24,"Export")
    GadgetToolTip(#g_playlist_export,"Export all files listed in the playlist")
    ;
    ; *** missing panel
    ;
    AddGadgetItem(#g_panel_main,-1,"Missing")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    ImageGadget(#g_missing_led,x+w-18,y,16,16,i_led_white_h)
    TextGadget(#g_missing_description,x,y,w-30,20,"List all non-exisiting files and folders referred to from any playlist. Can take a long time with many files / large playlists / slow servers.")
    y=y+25
    EditorGadget(#g_missing_list,x,y,w,h-58)
    y = h-15
    CheckBoxGadget(#g_missing_uselmspaths_toggle,x,y,16,16,"")
    TextGadget(#g_missing_uselmspaths_txt,x+20,y,100,20,"Use LMS paths")
    GadgetToolTip(#g_missing_uselmspaths_toggle,"Show paths from LMS perspective instead of SQB perspective.")
    xx = x+w-60-1*63
    ButtonGadget(#g_missing_run,xx,y,60,24,"Scan")
    GadgetToolTip(#g_missing_run,"Check all playlists for any missing files. This does NOT modify the playlists.")
    xx = xx+63
    ButtonGadget(#g_missing_copy,xx,y,60,24,"Copy")
    GadgetToolTip(#g_missing_copy,"Copy scan results and switch to 'Replace' tab.")
    ;
    ; *** replace panel
    ;
    AddGadgetItem(#g_panel_main,-1,"Replace")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    TextGadget(#g_replace_description,x,y,w,20,"Modify playlists. Format: 'old > new'. Any line without '>' will be ignored.")
    y = y+25
    EditorGadget(#g_replace_list,x,y,w,h-58)
    y = h-15
    CheckBoxGadget(#g_replace_existcheck_toggle,x,y,16,15,"")
    TextGadget(#g_replace_existcheck_txt,x+20,y,300,20,"Check existence")
    GadgetToolTip(#g_replace_existcheck_toggle,"Entry in playlist is only modified if the new path+file is valid and the file exists.")
    CheckBoxGadget(#g_replace_pointremember_toggle,x+120,y,16,15,"")
    TextGadget(#g_replace_pointremember_txt,x+140,y,300,20,"Remember last point")
    GadgetToolTip(#g_replace_pointremember_toggle,"Remember last folder for next point action.")
    xx = x+w-60-3*63
    ButtonGadget(#g_replace_clear,xx,y,60,24,"Clear")
    GadgetToolTip(#g_replace_clear,"Clear list.")
    xx = xx+63
    ButtonGadget(#g_replace_point,xx,y,60,24,"&Point")
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Alt|#PB_Shortcut_P,#f_point)
    GadgetToolTip(#g_replace_point,"Browse for the correct file and add path+file to the table above.")
    xx = xx+63
    ButtonGadget(#g_replace_applyplus,xx,y,60,24,"Apply+")
    GadgetToolTip(#g_replace_applyplus,"Modify ALL playlists using table above, then rescan for missing files and copy results.")
    xx = xx+63
    ButtonGadget(#g_replace_apply,xx,y,60,24,"Apply")
    GadgetToolTip(#g_replace_apply,"Modify ALL playlists using table above. Mark any files missing.")
    ;
    ; *** formats
    ;
    AddGadgetItem(#g_panel_main,-1,"Formats")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    ImageGadget(#g_formats_led,x+w-18,y,16,16,i_led_white_h)
    TextGadget(#g_formats_description,x,y,w-30,20,"List all music folders that contain videos or multiple types of music files. Doubleclick to explore.")
    y = y+25
    ListViewGadget(#g_formats_table,x,y,w,h-58)
    y = h-15
    ButtonGadget(#g_formats_run,x+w-60,y,60,24,"Scan")
    GadgetToolTip(#g_formats_run,"List all folders that contain videos or multiple types of music files.")
    ;
    ; *** information panel
    ;
    AddGadgetItem(#g_panel_main,-1,"Information")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    ImageGadget(#g_information_led,x+w-18,y,16,16,i_led_white_h)
    TextGadget(#g_information_description,x,y,w-30,20,"Lists program information, paths, and other settings and statistics.")
    y = y+25
    EditorGadget(#g_information_list,x,y,w,h-58,#PB_Editor_ReadOnly)
    y = h-15
    xx = x+w-60-0*63
    ButtonGadget(#g_information_run,xx,y,60,24,"Info")
    GadgetToolTip(#g_information_run,"Collect and display information.")
    ;
  CloseGadgetList()
  ;
  PanelGadget(#g_panel_transcopy,8,8,w_main_width-15,w_main_height-15)
    ;
    ; *** report panel
    ;
    AddGadgetItem(#g_panel_transcopy,-1,"Report")
    x = 8
    y = 8
    w = w_main_width-39
    h = w_main_height-57
    ;
    ImageGadget(#g_transcopy_led,x+w-18,y,16,16,i_led_white_h)
    TextGadget(#g_transcopy_description,x,y,w-30,20,"Copying and transcoding.")
    y = y+25
    ListIconGadget(#g_transcopy_table,x,y,w,h-58,"Activity",4000)
    y = h-15
    xx = x+w-60-0*63
    ButtonGadget(#g_transcopy_abort,xx,y,60,24,"Abort")
    GadgetToolTip(#g_transcopy_abort,"Stop copying and transcoding")
    ;
  CloseGadgetList()
  ;
  HideGadget(#g_panel_transcopy,1)
  ;
EndProcedure

Procedure updateordisable()
  ;
  ; *** handle gadgets that disable / enable / change state of other gadgets
  ;
  SetGadgetState(#g_prefs_uselmspaths_toggle,uselmspaths)
  SetGadgetState(#g_missing_uselmspaths_toggle,uselmspaths)
  DisableGadget(#g_prefs_uselmspaths_toggle,runningonserver)
  DisableGadget(#g_prefs_uselmspaths_txt,runningonserver)
  DisableGadget(#g_prefs_server_path,runningonserver)
  DisableGadget(#g_missing_uselmspaths_toggle,runningonserver)
  DisableGadget(#g_missing_uselmspaths_txt,runningonserver)
  If uselmspaths Or runningonserver
    DisableGadget(#g_missing_copy,#False)
    DisableGadget(#g_replace_applyplus,#False)
  Else
    DisableGadget(#g_missing_copy,#True)
    DisableGadget(#g_replace_applyplus,#True)
  EndIf
  ;
EndProcedure

Procedure fixpaths()
  ;
  ; *** make sure all paths end on a backslash
  ;
  If Right(music_path,1)<>"\"
    music_path = music_path+"\"
  EndIf
  If Right(playlist_path,1)<>"\"
    playlist_path = playlist_path+"\"
  EndIf
  If Right(server_path,1)<>"\"
    server_path = server_path+"\"
  EndIf
  If Right(export_path,1)<>"\"
    export_path = export_path+"\"
  EndIf
  ;
EndProcedure

Procedure setuserfields()
  ;
  ; *** fill gadgets with data from variables
  ;
  ; prefs
  ;
  SetGadgetText(#g_prefs_music_path,music_path)
  SetGadgetText(#g_prefs_playlist_path,playlist_path)
  SetGadgetText(#g_prefs_favorites_file,favorites_file)
  SetGadgetState(#g_prefs_runningonserver_toggle,runningonserver)
  SetGadgetState(#g_prefs_uselmspaths_toggle,uselmspaths)
  SetGadgetState(#g_prefs_refresh_toggle,reload)
  SetGadgetText(#g_prefs_server_path,server_path)
  SetGadgetState(#g_prefs_forceascii_toggle,forceascii)
  SetGadgetState(#g_prefs_warnings_toggle,warnings)
  SetGadgetText(#g_prefs_quircklevel_combo,Str(quircklevel))
  SetGadgetText(#g_prefs_explorerlaunch_path,explorerlaunch_file)
  SetGadgetText(#g_prefs_editorlaunch_path,editorlaunch_file)
  SetGadgetState(#g_prefs_exportasmp3_toggle,exportasmp3)
  SetGadgetText(#g_prefs_exe_path,sox_file)
  SetGadgetText(#g_prefs_bitrate_combo,mp3bitrate)
  SetGadgetText(#g_prefs_quality_combo,Str(conversionquality))
  SetGadgetText(#g_prefs_export_path,export_path)
  SetGadgetState(#g_prefs_exportfolders_toggle,exportfolders)
  SetGadgetState(#g_prefs_exportnumbers_toggle,exportnumber)
  SetGadgetState(#g_prefs_exportoverwrite_toggle,exportoverwrite)
  SetGadgetState(#g_prefs_exportusetemp_toggle,exportusetemp)
  SetGadgetState(#g_prefs_exportprefix_toggle,exportprefix)
  SetGadgetState(#g_prefs_hidesox_toggle,hidesox)
  SetGadgetState(#g_prefs_jobsmax_combo,jobsmax-1)
  ;
  ; playlist
  ;
  ; missing
  ;
  SetGadgetState(#g_missing_uselmspaths_toggle,runningonserver)
  ;
  ; replace
  ;
  SetGadgetText(#g_replace_list,replacelist)
  SetGadgetState(#g_replace_existcheck_toggle,replacecheck)
  SetGadgetState(#g_replace_pointremember_toggle,pointremember)
  ;
  ; disables
  ;
  updateordisable()
  ;
EndProcedure

Procedure savesettings()
  Protected f.s
  ;
  ; *** write settings to config file
  ;
  fixpaths()
  ;
  f = GetPathPart(ProgramFilename())+"sqb.cfg"
  CreatePreferences(f,#PB_Preference_GroupSeparator)
  ;
  PreferenceGroup("Prefs")
  WritePreferenceString("music_path",music_path)
  WritePreferenceString("playlist_path",playlist_path)
  WritePreferenceString("favorites_file",favorites_file)
  WritePreferenceString("server_path",server_path)
  WritePreferenceInteger("runningonserver",runningonserver)
  WritePreferenceInteger("uselmspaths",uselmspaths)
  WritePreferenceInteger("reload",reload)
  WritePreferenceInteger("warnings",warnings)
  WritePreferenceInteger("quircklevel",quircklevel)
  WritePreferenceInteger("forceascii",forceascii)
  WritePreferenceString("explorerlaunch_file",explorerlaunch_file)
  WritePreferenceString("editorlaunch_file",editorlaunch_file)
  WritePreferenceString("sox_file",sox_file)
  WritePreferenceInteger("exportasmp3",exportasmp3)
  WritePreferenceString("mp3bitrate",mp3bitrate)
  WritePreferenceInteger("conversionquality",conversionquality)
  WritePreferenceString("export_path",export_path)
  WritePreferenceInteger("exportfolders",exportfolders)
  WritePreferenceInteger("exportprefix",exportprefix)
  WritePreferenceInteger("exportnumber",exportnumber)
  WritePreferenceInteger("exportoverwrite",exportoverwrite)
  WritePreferenceInteger("exportusetemp",exportusetemp)
  WritePreferenceInteger("hidesox",hidesox)
  WritePreferenceInteger("jobsmax",jobsmax)
  ;
  PreferenceGroup("Playlists")
  ;
  PreferenceGroup("Missing")
  ;
  PreferenceGroup("Replace")
  WritePreferenceInteger("replacechek",replacecheck)
  WritePreferenceInteger("pointremember",pointremember)
  WritePreferenceString("replacelist",x_stringtostring(replacelist,16))
  ;
  ClosePreferences()
  ;
EndProcedure

Procedure loadsettings()
  Protected f.s
  ;
  ; *** read settings from config file
  ;
  f = GetPathPart(ProgramFilename())+"sqb.cfg"
  ;
  OpenPreferences(f)
  ;
  PreferenceGroup("Prefs")
  music_path = ReadPreferenceString("music_path","")
  playlist_path = ReadPreferenceString("playlist_path","")
  favorites_file = ReadPreferenceString("favorites_file","")
  server_path = ReadPreferenceString("server_path","")
  runningonserver = ReadPreferenceInteger("runningonserver",#False)
  uselmspaths = ReadPreferenceInteger("uselmspaths",#True)
  reload = ReadPreferenceInteger("reload",#True)
  warnings = ReadPreferenceInteger("warnings",#True)
  quircklevel = ReadPreferenceInteger("quircklevel",6)
  forceascii = ReadPreferenceInteger("forceascii",#True)
  explorerlaunch_file = ReadPreferenceString("explorerlaunch_file","")
  editorlaunch_file = ReadPreferenceString("editorlaunch_file","")
  sox_file = ReadPreferenceString("sox_file","")
  exportasmp3 = ReadPreferenceInteger("exportasmp3",#True)
  mp3bitrate = ReadPreferenceString("mp3bitrate","CBR 320")
  conversionquality = ReadPreferenceInteger("conversionquality",2)
  export_path = ReadPreferenceString("export_path","")
  exportfolders = ReadPreferenceInteger("exportfolders",#False)
  exportprefix = ReadPreferenceInteger("exportprefix",#True)
  exportnumber = ReadPreferenceInteger("exportnumber",#True)
  exportoverwrite = ReadPreferenceInteger("exportoverwrite",#True)
  exportusetemp = ReadPreferenceInteger("exportusetemp",#False)
  hidesox = ReadPreferenceInteger("hidesox",#False)
  jobsmax = ReadPreferenceInteger("jobsmax",1)
  ;
  PreferenceGroup("Playlists")
  ;
  PreferenceGroup("Missing")
  ;
  PreferenceGroup("Replace")
  replacecheck = ReadPreferenceInteger("replacechek",#True)
  pointremember = ReadPreferenceInteger("pointremember",#True)
  replacelist = x_stringtostring(ReadPreferenceString("replacelist",""),17)
  ;
  ClosePreferences()
  ;
  fixpaths()
  ;
EndProcedure

Procedure.s local2serverpath(path.s)
  ;
  ; *** oonvert a local path (as seen from the client) to a server path (as seen by the squeezebox server)
  ;
  If runningonserver
  Else
    path = ReplaceString(path,music_path,server_path,#PB_String_NoCase)
  EndIf
  ProcedureReturn path
EndProcedure

Procedure.s server2localpath(path.s)
  ;
  ; *** oonvert a aerver path (as seen by the squeezebox server) to a local path (as seen from the client) to
  ;
  If runningonserver
  Else
    path = ReplaceString(path,server_path,music_path,#PB_String_NoCase)
  EndIf
  ProcedureReturn path
EndProcedure

Procedure explorefolder(t.s)
  Protected e.s
  ;
  e = explorerlaunch_file
  If x_exist(e)
  Else
    e = "explorer.exe"
  EndIf
  RunProgram(e,#DQUOTE$+t+#DQUOTE$,#DQUOTE$+GetPathPart(t)+#DQUOTE$)
EndProcedure

Procedure editfile(t.s)
  Protected e.s
  ;
  e = editorlaunch_file
  If x_exist(e)
  Else
    e = "notepad.exe"
  EndIf
  RunProgram(e,#DQUOTE$+t+#DQUOTE$,#DQUOTE$+GetPathPart(t)+#DQUOTE$)
EndProcedure

Procedure folder_list()
  Protected t.s
  ;
  ; *** fill table with an overview of all folders
  ;
  fixpaths()
  HideGadget(#g_panel_main,#True)
  ClearGadgetItems(#g_folder_table)
  If music_path > ""
    x_dir(music_path,"*.*",1)
    ResetList(x_dir_file())
    While NextElement(x_dir_file())
      If x_dir_file()\type = #PB_DirectoryEntry_Directory
        t = x_dir_file()\name
        AddGadgetItem(#g_folder_table,-1,t)
      EndIf
    Wend
  EndIf
  HideGadget(#g_panel_main,#False)
EndProcedure

Procedure folder_export()
  Protected item_n.i, item_p.i, tag_n.i, tag_p.i, n.i, p.s, t.s, source.s, destination.s, conversion.i, temporary.s
  ;
  ; *** export selected folders
  ;
  ClearGadgetItems(#g_transcopy_table)
  HideGadget(#g_panel_main,1)
  HideGadget(#g_panel_transcopy,0)
  SetGadgetState(#g_transcopy_led,i_led_green_h)
  abort = #False
  jobs_n = 0
  ;
  item_n = CountGadgetItems(#g_folder_table)
  If item_n > 0
    ;
    ; count how many items are selected (this is only done for the progress bar)
    ;
    tag_n = 0
    tag_p = 0
    While tag_p < item_n
      If GetGadgetItemState(#g_folder_table,tag_p) > 0
        tag_n = tag_n+1
      EndIf
      tag_p = tag_p+1
    Wend
    ;
    item_p = 0
    tag_p = 0
    While item_p < item_n And abort = #False
      If GetGadgetItemState(#g_folder_table,item_p) > 0
        source = music_path+GetGadgetItemText(#g_folder_table,item_p)
        If x_folderexist(source)
          ;
          ; the selected entry is an existing folder, now export it
          ;
          destination = ReplaceString(source,music_path,export_path,#PB_String_NoCase)
          If Not x_folderexist(destination)
            CreateDirectory(destination)
          EndIf
          ;
          n = 0
          x_dir(source,"*.mp3|*.flac",5)
          ForEach x_dir_file()
            If abort = #False
              source = x_dir_file()\name
              destination = ReplaceString(source,music_path,export_path,#PB_String_NoCase)
              If x_dir_file()\type = #PB_DirectoryEntry_Directory
                ;
                ; subfolder
                ;
                If Not x_folderexist(destination)
                  CreateDirectory(destination)
                EndIf
              Else
                ;
                ; file
                ;
                conversion = #False
                If exportasmp3
                  If LCase(Right(destination,5)) = ".flac"
                    destination = x_chop(destination,0,5)+".mp3"
                    conversion = #True
                  EndIf
                EndIf
                ;
                If x_exist(destination) And exportoverwrite = #False
                  ;
                  ; skip existing files
                  ;
                  AddGadgetItem(#g_transcopy_table,-1,"skip "+source+" > "+destination)
                  ;
                ElseIf Not conversion
                  ;
                  ; if conversion isn't necessary files are copied directly
                  ;
                  SetGadgetState(#g_transcopy_led,i_led_green_h)
                  CopyFile(source,destination)
                  AddGadgetItem(#g_transcopy_table,-1,"copy "+source+" > "+destination)
                  ;
                Else
                  ;
                  ; convert .flac to .mp3 using sox
                  ;
                  ; sox -S <source> -C 128.9 <destination>
                  ;
                  p = "-S "+#DQUOTE$+source+#DQUOTE$
                  If Left(mp3bitrate,3) = "CBR"                                  ; CBR, use positive parameter for sox
                    p = p+" -C "+Right(mp3bitrate,3)
                  Else                                                           ; VBR, use negative parameter for sox
                    p = p+" -C -"+Mid(mp3bitrate,5,1)
                  EndIf
                  If conversionquality = 0
                    p = p+".99 "
                  Else
                    p = p+"."+Str(conversionquality)+" "
                  EndIf
                  p = p+#DQUOTE$+destination+#DQUOTE$
                  ;
                  ; add transcode job
                  ;
                  AddGadgetItem(#g_transcopy_table,-1,"transcode "+source+" > "+destination)
                  AddElement(jobs_id())
                  If hidesox
                    jobs_id() = RunProgram(sox_file,p,GetPathPart(sox_file),#PB_Program_Open|#PB_Program_Hide)
                  Else
                    jobs_id() = RunProgram(sox_file,p,GetPathPart(sox_file),#PB_Program_Open)
                  EndIf
                  jobs_n = jobs_n+1
                  ;
                EndIf
              EndIf
              ;
              ; there may be conversions running in the background, if so add some time to handling windows events
              ; check for the abort button
              ;
              Repeat
                Repeat
                  event = WindowEvent()
                  event_gadget = EventGadget()
                  If event_gadget = #g_transcopy_abort
                    abort = #True
                  EndIf
                Until event = 0
                If jobs_n = jobsmax
                  SetGadgetState(#g_transcopy_led,i_led_red_h)
                  event = WaitWindowEvent(512)
                  event_gadget = EventGadget()
                  If event_gadget = #g_transcopy_abort
                    abort = #True
                    SetGadgetState(#g_transcopy_led,i_led_yellow_h)
                  EndIf
                EndIf
                ;
                ; did any instances finish yet
                ;
                ResetList(jobs_id())
                While NextElement(jobs_id())
                  If ProgramRunning(jobs_id()) = 0
                    DeleteElement(jobs_id())
                    jobs_n = jobs_n-1
                  EndIf
                Wend
              Until abort = #True Or jobs_n < jobsmax
              ;
              n = n+1
              SetGadgetState(#g_progress,1000*tag_p/tag_n+950*n/tag_n/x_dir_n)
            EndIf
            SendMessage_(GadgetID(#g_transcopy_table), #LVM_ENSUREVISIBLE, CountGadgetItems(#g_transcopy_table) - 1, #True)
            ;
            If abort = #True
              Break
            EndIf
            ;
          Next
          tag_p =tag_p+1
        EndIf
      EndIf
      item_p = item_p+1
    Wend
  EndIf
  ;
  SetGadgetState(#g_transcopy_led,i_led_yellow_h)
  Repeat
    event = WaitWindowEvent(512)
    ResetList(jobs_id())
    While NextElement(jobs_id())
      If ProgramRunning(jobs_id()) = 0
        DeleteElement(jobs_id())
        jobs_n = jobs_n-1
        AddGadgetItem(#g_transcopy_table,-1,"finishing "+Str(jobs_n))
        SendMessage_(GadgetID(#g_transcopy_table), #LVM_ENSUREVISIBLE, CountGadgetItems(#g_transcopy_table) - 1, #True)
      EndIf
    Wend
  Until jobs_n = 0
  ;
  HideGadget(#g_panel_transcopy,1)
  HideGadget(#g_panel_main,0)
  SetGadgetState(#g_transcopy_led,i_led_green_h)
  SetGadgetState(#g_progress,0)
  ;
EndProcedure

Procedure playlist_list()
  Protected t.s, p.i
  ;
  ; *** fill table with an overview of all playlists
  ;
  ;
  ; create a copy of the favorites list, if possible
  ;
  fixpaths()
  If x_existx(favorites_file)
    ReadFile(1,favorites_file)
    If forceascii = #True
      x_excreateFile(2,playlist_path+"lms_favorites.m3u",#PB_Ascii)    ; create a file, doesn't add bom
    Else
      x_excreateFile(2,playlist_path+"lms_favorites.m3u",#PB_UTF8)     ; create utf8 file, adds bom
      WriteStringFormat(2,#PB_UTF8)
    EndIf
    While Not Eof(1)
      t = ReadString(1)
      t = Trim(t)
      If Left(t,8) = "<outline"
        t = x_stringtostring(t,18)
        t = ReplaceString(t,"<outline URL="+#DQUOTE$+"file:\\\","")
        p = FindString(t,#DQUOTE$)
        If p > 0
          t = Left(t,p-1)
          If forceascii = #True
            WriteString(2,t+#CRLF$,#PB_Ascii)
          Else
            WriteString(2,t+#CRLF$,#PB_UTF8)
          EndIf
        EndIf
      EndIf
    Wend
    CloseFile(1)
    CloseFile(2)
  EndIf
  ;
  ; then fill the list
  ;
  HideGadget(#g_panel_main,#True)
  ClearGadgetItems(#g_playlist_table)
  If playlist_path > ""
    x_dir(playlist_path,"*.m3u",1)
    ResetList(x_dir_file())
    While NextElement(x_dir_file())
      If x_dir_file()\type = #PB_DirectoryEntry_File
        t = x_dir_file()\name
        AddGadgetItem(#g_playlist_table,-1,t)
      EndIf
    Wend
  EndIf
  HideGadget(#g_panel_main,#False)
EndProcedure

Procedure playlist_strip(t.s)
  Protected x.s
  ;
  ; *** remove comments etc. from the playlist
  ;
  fixpaths()
  x_excopyfile(1,t,2,t+".bak")
  If x_exreadfile(1,t+".bak",#PB_UTF8) = 0
    skipped = skipped +1
    Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
  Else
    ReadStringFormat(1)                                                ; strip eventual bom
    If forceascii = #True
      x_excreateFile(2,t,#PB_Ascii)                                    ; create a file, doesn't add bom
    Else
      x_excreateFile(2,t,#PB_UTF8)                                     ; create utf8 file, adds bom
      WriteStringFormat(2,#PB_UTF8)
    EndIf
    While Not Eof(1)
      x = Trim(ReadString(1))
      x = x_stringtostring(x,18)                                       ; strip / replace html style characters
      If Left(x,1) = "#" And Left(x,8) <> "#MISSING"                   ; strip regular remark # tags, but leave in $#MISSING lines
      ElseIf x = ""                                                    ; strip empty lines
      ElseIf forceascii = #True
        WriteString(2,x+#CRLF$,#PB_Ascii)
      Else
        WriteString(2,x+#CRLF$,#PB_UTF8)
      EndIf
    Wend
    CloseFile(1)
    CloseFile(2)
  EndIf
  ;
  ; launch external editor, for example notepad
  ;
  editfile(t)
  ;
EndProcedure

Procedure playlist_sort(t.s)
  Protected x.s, y.s
  Protected NewList files.s()
  ;
  ; *** process the playlist, remove all # except for #MISSING, then sort
  ;
  fixpaths()
  x_excopyfile(1,t,2,t+".bak")
  If x_exreadfile(1,t+".bak",#PB_UTF8) = 0
    skipped = skipped +1
    Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
  Else
    x_exreadfile(1,t+".bak",#PB_UTF8)
    ReadStringFormat(1)                                                ; strip eventual bom
    While Not Eof(1)
      x = Trim(ReadString(1))
      x = x_stringtostring(x,18)                                       ; strip / replace html style characters
      If x = ""
      ElseIf Left(x,1) = "#" And Left(x,8) <> "#MISSING"               ; remove any comment lines except for #MISSING
      Else
        AddElement(files())
        files() = x
      EndIf
    Wend
    ;
    SortList(files(),#PB_Sort_Ascending)                               ; sort the list
    ;
    If forceascii = #True
      x_excreatefile(2,t,#PB_Ascii)                                        ; create a file, doesn't add bom
    Else
      x_excreatefile(2,t,#PB_UTF8)                                         ; create utf8 file, adds bom
      WriteStringFormat(2,#PB_UTF8)
    EndIf
    ForEach files()                                                        ; go through playlist
      If forceascii = #True
        WriteString(2,files()+#CRLF$,#PB_Ascii)
      Else
        WriteString(2,files()+#CRLF$,#PB_UTF8)
      EndIf
    Next
    CloseFile(1)
    CloseFile(2)
  EndIf
  ;
  ; launch external editor, for example notepad
  ;
  editfile(t)
  ;
EndProcedure

Procedure playlist_shuffle(t.s)
  Protected x.s, y.s, n.i, nn.i, d.i, p.i, a.s, b.s, c.s, q.i
  Protected NewList files.s()
  Protected NewList buffer.s()
  ;
  ; *** process the playlist, remove all # except for #MISSING, then sort, then shuffle
  ;
  ; note: this only works well for playlists with enough entries
  ;
  fixpaths()
  x_excopyfile(1,t,2,t+".bak")
  If x_exreadfile(1,t+".bak",#PB_UTF8) = 0
    skipped = skipped +1
    Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
  Else
    x_exreadfile(1,t+".bak",#PB_UTF8)
    ReadStringFormat(1)                                                ; strip eventual bom
    While Not Eof(1)
      x = Trim(ReadString(1))
      x = x_stringtostring(x,18)                                       ; strip / replace html style characters
      If x = ""
      ElseIf Left(x,1) = "#" And Left(x,8) <> "#MISSING"               ; remove any comment lines except for #MISSING
      Else
        AddElement(files())
        files() = x
      EndIf
    Wend
    ;
    ; first sort the list
    ;
    SortList(files(),#PB_Sort_Ascending)
    ;
    ; move part of the list towards the end to make sure it doesn't always start and end with the same files
    ;
    If ListSize(files()) > 6
      n = x_max(0,Random(ListSize(files()))-5)
      If n > 0
        ResetList(files())
        ClearList(buffer())
        For nn = 0 To n
          NextElement(files())
          AddElement(buffer())
          buffer() = files()
          DeleteElement(files())
        Next nn
        ResetList(buffer())
        LastElement(files())
        While NextElement(buffer())
          AddElement(files())
          files() = buffer()
        Wend
      EndIf
    EndIf
    ;
    ; do a dispersed shuffle over 16 bands (17 insert points) with a random component
    ;
    DataSection
      dispersiontable:
      Data.i 0
      Data.i 8
      Data.i 4
      Data.i 12
      Data.i 2
      Data.i 14
      Data.i 6
      Data.i 10
      Data.i 1
      Data.i 13
      Data.i 3
      Data.i 16
      Data.i 9
      Data.i 5
      Data.i 11
      Data.i 15
      Data.i 7
      Data.i 0
    EndDataSection
    ;
    Restore dispersiontable
    n = Random(15)
    For nn = 1 To n
      Read.i p
    Next nn
    ;
    ResetList(files())
    ClearList(buffer())
    While NextElement(files())
      ;
      ; calculate an insert point
      ;
      Read.i p
      If p = 0
        Restore dispersiontable
        Read.i p
      EndIf
      d = x_max((0.5+ListSize(buffer())/16),1) ; 16 segments, all insert pints are at the boundary of the segments, and at the first and last position, so total 17 insert points
      q = Random(d)-d/2                        ; add a random distance from the insert point
      p = p*d+q
      If p < 0                                 ; do wrap around at begin and end
        p = p+ListSize(buffer())
      EndIf
      If p > ListSize(buffer())
        p = p-ListSize(buffer())
      EndIf
      p = x_limit(p,0,ListSize(buffer()))
      ;
      If p = ListSize(buffer())
        LastElement(buffer())
        AddElement(buffer())
        buffer() = files()
      Else
        SelectElement(buffer(),p)
        InsertElement(buffer())
        buffer() = files()
      EndIf
    Wend
    ;
    ; break up clusters from the same folder if possible by moving similars up to 20 spots up and down
    ;
    If ListSize(files()) > 6
      For n = 1 To 20
        ;
        ClearList(files())
        ResetList(buffer())
        While NextElement(buffer())
          InsertElement(files())
          files() = buffer()
        Wend
        ;
        ClearList(buffer())
        ResetList(files())
        NextElement(files())
        a = files()
        NextElement(files())
        b = files()
        While NextElement(files())
          c = files()
          If GetPathPart(a) = GetPathPart(b)
            Swap b,c
          EndIf
          AddElement(buffer())
          buffer() = a
          a = b
          b = c
        Wend
        AddElement(buffer())
        buffer() = a
        AddElement(buffer())
        buffer() = b
        ;
      Next n
    EndIf
    ;
    ; export the resulting file
    ;
    If forceascii = #True
      x_excreatefile(2,t,#PB_Ascii)                                        ; create a file, doesn't add bom
    Else
      x_excreatefile(2,t,#PB_UTF8)                                         ; create utf8 file, adds bom
      WriteStringFormat(2,#PB_UTF8)
    EndIf
    ForEach buffer()                                                       ; go through playlist
      If forceascii = #True
        WriteString(2,buffer()+#CRLF$,#PB_Ascii)
      Else
        WriteString(2,buffer()+#CRLF$,#PB_UTF8)
      EndIf
    Next
    CloseFile(1)
    CloseFile(2)
  EndIf
  ;
EndProcedure

Procedure playlist_mix()
  Protected f1.s, f2.s, fmix.s, ftemp.s, choice.i, r.i, f.s, x.s, step1.f, step2.f, treshold1.f, treshold2.f, n.i, a.s, b.s, c.s, t.s, quirck.i, rr.i
  Protected NewList files1.s()
  Protected NewList files2.s()
  Protected NewList filesmix.s()
  Protected NewList buffer.s()
  ;
  Repeat
    f1 = OpenFileRequester("Mix - select source 1",playlist_path,"*.m3u|*.m3u",0)
  Until f1 = "" Or x_exist(f1)
  If x_exist(f1)
    Repeat
      f2 = OpenFileRequester("Mix - select source 2",playlist_path,"*.m3u|*.m3u",0)
    Until f2 = "" Or x_exist(f2)
    If x_exist(f2)
      r = 0
      Repeat
        fmix = SaveFileRequester("Mix - select destination",playlist_path,"*.m3u|*.m3u",0)
        If fmix = ""
          r = -1
        Else
          If LCase(Right(fmix,4)) <> ".m3u"
            fmix = fmix+".m3u"
          EndIf
          If x_exist(fmix)
            r = MessageRequester("Mix","File already exists. Overwrite?",#PB_MessageRequester_YesNoCancel)
            If r = #PB_MessageRequester_No
              r = 0
            ElseIf r = #PB_MessageRequester_Yes
              CopyFile(fmix,fmix+".bak")
              r = 1
            Else
              r = -1
            EndIf
          Else
            r = 1
          EndIf
        EndIf
      Until r <> 0
      If r = 1
        ;
        ; all conditions met, we have a source and destination
        ;
        ftemp.s = playlist_path+"sqbtemp.tmp"
        ;
        ; shuffle and read file 1
        ;
        CopyFile(f1,ftemp)
        playlist_shuffle(ftemp)
        x_exreadfile(1,ftemp,#PB_UTF8)
        ReadStringFormat(1)                                                ; strip eventual bom
        While Not Eof(1)
          x = Trim(ReadString(1))
          x = x_stringtostring(x,18)                                       ; strip / replace html style characters
          If x = ""
          ElseIf Left(x,1) = "#" And Left(x,8) <> "#MISSING"               ; remove any comment lines except for #MISSING
          Else
            AddElement(files1())
            files1() = x
          EndIf
        Wend
        CloseFile(1)
        DeleteFile(ftemp)
        ;
        ; shuffle and read file 2
        ;
        CopyFile(f2,ftemp)
        playlist_shuffle(ftemp)
        x_exreadfile(1,ftemp,#PB_UTF8)
        ReadStringFormat(1)                                                ; strip eventual bom
        While Not Eof(1)
          x = Trim(ReadString(1))
          x = x_stringtostring(x,18)                                       ; strip / replace html style characters
          If x = ""
          ElseIf Left(x,1) = "#" And Left(x,8) <> "#MISSING"               ; remove any comment lines except for #MISSING
          Else
            AddElement(files2())
            files2() = x
          EndIf
        Wend
        CloseFile(1)
        DeleteFile(ftemp)
        ;
        ; define ratio between inserts from list 1 and 2
        ;
        step2 = ListSize(files2())/ListSize(files1())
        step1 = 1
        If step2 > 1
          step1 = 1/step2
          step2 = 1
        EndIf
        If step1 < step2
          treshold1 = Random(1)
          treshold2 = 0
        Else
          treshold1 = 0
          treshold2 = Random(1)
        EndIf
        step1 = step1/2
        step2 = step2/2
        ResetList(files1())
        ResetList(files2())
        ;
        ; a perfect interleave is annoying, so I've added a random factor, the 'quirckalizer' based on 'quirck' particles
        ;
        quirck = 6
        ;
        ; go through the lists and output elements
        ;
        rr = 0
        While ListIndex(files1()) < ListSize(files1())-1 And ListIndex(files2()) < ListSize(files2())-1
          If rr = 0
            rr = Random(quirck)
            If quirck = 0
              r = 0
            Else
              r = Random(10)
              If Random(quirck*2) < 1
                r = 0
              EndIf
            EndIf
          Else
            rr = rr-1
          EndIf
          Select r
              Case 0,1,4,6,7,8,9
                treshold1 = treshold1+step1
                treshold2 = treshold2+step2
          EndSelect
          Select r
              Case 0,2,4,5,7,8
                If treshold1 >= 1
                  treshold1 = treshold1-1.0
                  NextElement(files1())
                  AddElement(filesmix())
                  filesmix() = files1()
                EndIf
          EndSelect
          Select r
              Case 0,3,5,6,7,8
                If treshold2 >= 1
                  treshold2 = treshold2-1.0
                  NextElement(files2())
                  AddElement(filesmix())
                  filesmix() = files2()
                EndIf
          EndSelect
        Wend
        ;
        ; there may be some entries left, output those too
        ;
        While NextElement(files1())
          AddElement(filesmix())
          filesmix() = files1()
        Wend
        While NextElement(files2())
          AddElement(filesmix())
          filesmix() = files2()
        Wend
        ;
        ; break up clusters from the same folder if possible by moving similars up to 20 spots up and down (probably won't happen, but still)
        ;
        If ListSize(filesmix()) > 6
          For n = 1 To 20
            ;
            ClearList(buffer())
            ResetList(filesmix())
            NextElement(filesmix())
            a = filesmix()
            NextElement(filesmix())
            b = filesmix()
            While NextElement(filesmix())
              c = filesmix()
              If GetPathPart(a) = GetPathPart(b)
                Swap b,c
              EndIf
              AddElement(buffer())
              buffer() = a
              a = b
              b = c
            Wend
            AddElement(buffer())
            buffer() = a
            AddElement(buffer())
            buffer() = b
            ;
            ClearList(filesmix())
            ResetList(buffer())
            While NextElement(buffer())
              InsertElement(filesmix())
              filesmix() = buffer()
            Wend
            ;
          Next n
        EndIf
        ;
        ; export the resulting file
        ;
        If forceascii = #True
          x_excreatefile(2,fmix,#PB_Ascii)                                     ; create a file, doesn't add bom
        Else
          x_excreatefile(2,fmix,#PB_UTF8)                                      ; create utf8 file, adds bom
          WriteStringFormat(2,#PB_UTF8)
        EndIf
        ForEach filesmix()                                                     ; go through playlist
          If forceascii = #True
            WriteString(2,filesmix()+#CRLF$,#PB_Ascii)
          Else
            WriteString(2,filesmix()+#CRLF$,#PB_UTF8)
          EndIf
        Next
        CloseFile(2)
        ;
        If warnings
          t = "Input"
          t = t+#CRLF$+#CRLF$+"  "+GetFilePart(f1)+" ("+Str(ListSize(files1()))+" songs)"
          t = t+#CRLF$+"  "+GetFilePart(f2)+" ("+Str(ListSize(files2()))+" songs)"
          t = t+#CRLF$+#CRLF$+"Output"
          t = t+#CRLF$+#CRLF$+"  "+GetFilePart(fmix)+" ("+Str(ListSize(filesmix()))+" songs)"
          MessageRequester("Mix results",t,#PB_MessageRequester_Ok)
        EndIf
        ;
        editfile(fmix)
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure playlist_mark(t.s)
  Protected x.s, y.s
  ;
  ; *** process the playlist, remove comments and mark missing files
  ;
  fixpaths()
  x_excopyfile(1,t,2,t+".bak")
  If x_exreadfile(1,t+".bak",#PB_UTF8) = 0
    skipped = skipped +1
    Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
  Else
    x_exreadfile(1,t+".bak",#PB_UTF8)
    ReadStringFormat(1)                                                ; strip eventual bom
    If forceascii = #True
      x_excreatefile(2,t,#PB_Ascii)                                    ; create a file, doesn't add bom
    Else
      x_excreatefile(2,t,#PB_UTF8)                                     ; create utf8 file, adds bom
      WriteStringFormat(2,#PB_UTF8)
    EndIf
    While Not Eof(1)
      x = Trim(ReadString(1))
      x = x_stringtostring(x,18)                                       ; strip / replace html style characters
      If Left(x,8) = "#MISSING"                                        ; remove the #MISSING tag to allow re-check of the file
        x = Mid(x,10,512)
      EndIf
      If Left(x,1) = "#" Or x = ""                                     ; remove any remaining comments and empty lines
      Else
        y = server2localpath(x)
        If x_exist(y)
        Else
          x = "#MISSING "+x
        EndIf
        If forceascii = #True
          WriteString(2,x+#CRLF$,#PB_Ascii)
        Else
          WriteString(2,x+#CRLF$,#PB_UTF8)
        EndIf
      EndIf
    Wend
    CloseFile(1)
    CloseFile(2)
  EndIf
  ;
  ; launch external editor, for example notepad
  ;
  editfile(t)
  ;
EndProcedure

Procedure playlist_deduplicate(t.s)
  Protected x.s, y.s
  Protected NewList files.s()
  ;
  ; *** process the playlist, remove all #, sort, remove all duplicates, mark all #MISSING
  ;
  fixpaths()
  x_excopyfile(1,t,2,t+".bak")
  If x_exreadfile(1,t+".bak",#PB_UTF8) = 0
    skipped = skipped +1
    Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
  Else
    x_exreadfile(1,t+".bak",#PB_UTF8)
    ReadStringFormat(1)                                                ; strip eventual bom
    While Not Eof(1)
      x = Trim(ReadString(1))
      x = x_stringtostring(x,18)                                       ; strip / replace html style characters
      If Left(x,8) = "#MISSING"                                        ; remove the #MISSING tag to allow re-check of the file
        x = Mid(x,10,512)
      EndIf
      If Left(x,1) = "#" Or x = ""                                     ; remove any remaining comments and empty lines
      Else
        AddElement(files())
        files() = x
      EndIf
    Wend
    ;
    SortList(files(),#PB_Sort_Ascending)                               ; sort the list
    ResetList(files())
    x.s = ""
    While ListSize(files())>0 And NextElement(files())                 ; scan for duplicates
      If files() = x
        DeleteElement(files())                                         ; remove duplicates
      Else
        x = files()
      EndIf
    Wend
    ;
    If forceascii = #True
      x_excreatefile(2,t,#PB_Ascii)                                    ; create a file, doesn't add bom
    Else
      x_excreatefile(2,t,#PB_UTF8)                                     ; create utf8 file, adds bom
      WriteStringFormat(2,#PB_UTF8)
    EndIf
    ForEach files()                                                    ; go through playlist
      x = files()
      y = server2localpath(x)
      If x_exist(y)
      Else
        x = "#MISSING "+x                                              ; mark missing files
      EndIf
      If forceascii = #True
        WriteString(2,x+#CRLF$,#PB_Ascii)
      Else
        WriteString(2,x+#CRLF$,#PB_UTF8)
      EndIf
    Next
    CloseFile(1)
    CloseFile(2)
  EndIf
  ;
  ; launch external editor, for example notepad
  ;
  editfile(t)
  ;
EndProcedure

Procedure playlist_export(t.s)
  Protected x.s, n.i, f.s, path.s, name.s, p.s, converted.s, source.s, extension.s, temporary.s, destination.s, conversion.i, z.i
  Protected NewList files.s()
  ;
  ; *** export selected playlist
  ;
  ; prepare
  ;
  fixpaths()
  ClearGadgetItems(#g_transcopy_table)
  HideGadget(#g_panel_main,1)
  HideGadget(#g_panel_transcopy,0)
  SetGadgetState(#g_transcopy_led,i_led_green_h)
  abort = #False
  jobs_n = 0
  ;
  ; read the playlist
  ;
  n = 0
  x_exreadfile(1,t,#PB_UTF8)                                               ; open playlist
  ReadStringFormat(1)                                                      ; skip eventual bom
  ;
  While Not Eof(1)
    x = Trim(ReadString(1))
    x = x_stringtostring(x,18)                                             ; strip / replace html style characters
    If Left(x,1) = "#"                                                     ; strip all comments and missing
    ElseIf x = ""
    Else
      x = server2localpath(x)
      If x_exist(x)                                                        ; check if the file actually exists
        AddElement(files())
        files() = x
      EndIf
    EndIf
  Wend
  CloseFile(1)
  ;
  n = 0
  If ListSize(files()) > 0
    ;
    ForEach files()
      If abort = #False
        source = files()
        destination = files()
        ;
        ; build destination path and name
        ;
        If exportfolders                                                                               ; use the folder where the mp3 was located
          path = ReplaceString(GetPathPart(destination),music_path,export_path,#PB_String_NoCase)
        Else                                                                                           ; use the playlist name as a folder
          path = export_path+GetFilePart(t,#PB_FileSystem_NoExtension)+"\"
        EndIf
        If exportprefix = #True ; and FindString(path,"\") > 3
          path = x_chop(path,0,1)
          z = x_rfindstring(path,"\")
          path = Left(path,z)+"playlist - "+Mid(path,z+1,256)+"\"
        EndIf
        If exportnumber                                                                                ; put a 4 digit number in front of the filename (allowing top 999's :-))
          name = x_strex(n,"####")+" - "+GetFilePart(destination)
        Else                                                                                           ; leave name as is
          name = GetFilePart(destination)
        EndIf
        conversion = #False
        If exportasmp3
          If LCase(Right(name,5)) = ".flac"
            name = x_chop(name,0,5)+".mp3"
            conversion = #True
          EndIf
        EndIf
        destination = path+name
        ;
        ; create export folder structure if needed
        ;
        If Not x_folderexist(path)                                                                     ; create folder if destination path doesn't exist
          CreateDirectory(path)
        EndIf
        ;
        If x_exist(destination) And exportoverwrite = #False
          ;
          ; skip existing files
          ;
          AddGadgetItem(#g_transcopy_table,-1,"skip "+source+" > "+destination)
          ;
        ElseIf Not conversion
          ;
          ; if conversion isn't necessary files are copied directly
          ;
          SetGadgetState(#g_transcopy_led,i_led_green_h)
          CopyFile(source,destination)
          AddGadgetItem(#g_transcopy_table,-1,"copy "+source+" > "+destination)
          ;
        Else
          ;
          ; convert .flac to .mp3 using sox
          ;
          ; sox -S <source> -C 128.9 <destination>
          ;
          p = "-S "+#DQUOTE$+source+#DQUOTE$
          If Left(mp3bitrate,3) = "CBR"                                  ; CBR, use positive parameter for sox
            p = p+" -C "+Right(mp3bitrate,3)
          Else                                                           ; VBR, use negative parameter for sox
            p = p+" -C -"+Mid(mp3bitrate,5,1)
          EndIf
          If conversionquality = 0
            p = p+".99 "
          Else
            p = p+"."+Str(conversionquality)+" "
          EndIf
          p = p+#DQUOTE$+destination+#DQUOTE$
          ;
          ; add transcode job
          ;
          AddGadgetItem(#g_transcopy_table,-1,"transcode "+source+" > "+destination)
          AddElement(jobs_id())
          If hidesox
            jobs_id() = RunProgram(sox_file,p,GetPathPart(sox_file),#PB_Program_Open|#PB_Program_Hide)
          Else
            jobs_id() = RunProgram(sox_file,p,GetPathPart(sox_file),#PB_Program_Open)
          EndIf
          jobs_n = jobs_n+1
          ;
        EndIf
        ;
        ; there may be conversions running in the background, if so add some time to handling windows events
        ; check for the abort button
        ;
        Repeat
          Repeat
            event = WindowEvent()
            event_gadget = EventGadget()
            If event_gadget = #g_transcopy_abort
              abort = #True
            EndIf
          Until event = 0
          If jobs_n = jobsmax
            SetGadgetState(#g_transcopy_led,i_led_red_h)
            event = WaitWindowEvent(512)
            event_gadget = EventGadget()
            If event_gadget = #g_transcopy_abort
              abort = #True
              SetGadgetState(#g_transcopy_led,i_led_yellow_h)
            EndIf
          EndIf
          ;
          ; did any instances finish yet
          ;
          ResetList(jobs_id())
          While NextElement(jobs_id())
            If ProgramRunning(jobs_id()) = 0
              DeleteElement(jobs_id())
              jobs_n = jobs_n-1
            EndIf
          Wend
        Until abort = #True Or jobs_n < jobsmax
        ;
        n = n+1
        SetGadgetState(#g_progress,1000*n/ListSize(files()))
      EndIf
      ;
      SendMessage_(GadgetID(#g_transcopy_table), #LVM_ENSUREVISIBLE, CountGadgetItems(#g_transcopy_table) - 1, #True)
      ;
      If abort = #True
        Break
      EndIf
      ;
    Next
  EndIf
  ;
  SetGadgetState(#g_transcopy_led,i_led_yellow_h)
  Repeat
    event = WaitWindowEvent(512)
    ResetList(jobs_id())
    While NextElement(jobs_id())
      If ProgramRunning(jobs_id()) = 0
        DeleteElement(jobs_id())
        jobs_n = jobs_n-1
        AddGadgetItem(#g_transcopy_table,-1,"finishing "+Str(jobs_n))
        SendMessage_(GadgetID(#g_transcopy_table), #LVM_ENSUREVISIBLE, CountGadgetItems(#g_transcopy_table) - 1, #True)
      EndIf
    Wend
  Until jobs_n = 0
  ;
  HideGadget(#g_panel_transcopy,1)
  HideGadget(#g_panel_main,0)
  SetGadgetState(#g_transcopy_led,i_led_green_h)
  SetGadgetState(#g_progress,0)
  ;
EndProcedure

Procedure playlists_scan()
  Protected n.i, nn.i, nnn.i, file.s, t.s, playlist.s, x.s, count.i, playlist_flagged.i, playlist_flagged_n.i, q.s
  Protected NewList files.s()
  Protected NewMap folders.s()
  Protected NewList folders_sorted.s()
  ;
  ; *** list all missing files and folders that any playlist refers to
  ;
  ; approach:
  ;
  ; 1. go through all playlists
  ; 2. find all missing files
  ; 3. deduct all missing folders
  ; 4. list missing folders
  ; 5. list folders that miss files
  ; 6. list playlists missing files
  ;
  ; so... here we go (combining three in one go)
  ;
  ; 1. go through all playlists
  ; 2. find file entries that point nowhere (missing files)
  ; 6. list playlists missing files
  ;
  fixpaths()
  ;
  If music_path > "" And playlist_path > ""
    DisableGadget(#g_missing_run,1)
    DisableGadget(#g_missing_copy,1)
    SetGadgetState(#g_missing_led,i_led_red_h)
    SetGadgetState(#g_progress,100)
    ClearGadgetItems(#g_missing_list)
    ;
    Repeat
      event = WaitWindowEvent(1)
    Until event = 0
    ;
    AddGadgetItem(#g_missing_list,-1,"Playlists missing files")
    AddGadgetItem(#g_missing_list,-1,"")
    x_dir(playlist_path,"*.m3u",2,0)
    ResetList(x_dir_file())
    playlist_flagged_n = 0                                ; counter for playlists that miss files
    ForEach x_dir_file()
      playlist = x_dir_file()\name
      playlist_flagged = #False                           ; set to true if it is missing any files
      If x_exreadfile(1,playlist,#PB_UTF8) = 0            ; sometimes opening a playlist fails on the server, could be LMS, virus scanner, something else?
        skipped = skipped+1
        Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
      Else
        ReadStringFormat(1)                               ; skip bom ($FE $FF or similar, marking the file as UTF8, UTF16 etc.)
        While Not Eof(1)
          file = Trim(ReadString(1))
          file = x_stringtostring(file,18)                ; strip / replace html style characters
          If Left(file,8) = "#MISSING"                    ; strip #MISSING to allow recheck for missing files
            file = Mid(file,10,512)
          EndIf
          If file = "" Or Left(file,1) = "#"              ; strip empty lines and comments
          Else                                            ; anything left over should be a file entry
            t = LCase(file)
            If runningonserver                            ; do not modify file path if its running on server
            Else                                          ; when running remotely then replace LMS path with client (network) path to the file
              t = server2localpath(t)
            EndIf
            If Not x_exist(t)                             ; so here we finally check if the file is misisng
              AddElement(files())                         ; if so add it to the list of missing files
              files() = t
              If playlist_flagged                         ; and report the playlist as missing some files if that hasn't done before
              Else
                AddGadgetItem(#g_missing_list,-1,GetFilePart(playlist))
                playlist_flagged = #True
                playlist_flagged_n = playlist_flagged_n+1
              EndIf
            EndIf
          EndIf
        Wend
        CloseFile(1)
      EndIf
      ;
      n = n+1
      SetGadgetState(#g_progress,100+700*n/x_dir_n)
      ;
    Next
    SortList(files(),#PB_Sort_Ascending)
    ;
    If playlist_flagged_n = 0
      AddGadgetItem(#g_missing_list,-1,"None")
    EndIf
    ;
    ; 3a. sort files and remove duplicates
    ;
    If ListSize(files()) > 0
      SortList(files(),#PB_Sort_Ascending)
      ResetList(files())
      NextElement(files())
      x.s = files()
      While ListSize(files()) > 1 And NextElement(files())
        If files() = x
          DeleteElement(files())
        Else
          x = files()
        EndIf
      Wend
    EndIf
    ;
    ; 3. go through the files and deduct missing folders
    ;
    If ListSize(files()) > 0
      ResetList(files())
      ForEach files()
        t = GetPathPart(files())
        folders(t) = t                                    ; using a map to avoid duplicate path entries
      Next
      ForEach folders()                                   ; copy the created map to a list so it can be sorted for display purposes
        AddElement(folders_sorted())
        folders_sorted() = folders()
      Next
      SortList(folders_sorted(),#PB_Sort_Ascending)
    EndIf
    ;
    ; list other results
    ;
    ; 4. folders mssing
    ;
    count = 0
    AddGadgetItem(#g_missing_list,-1,"")
    AddGadgetItem(#g_missing_list,-1,"Missing folders")
    AddGadgetItem(#g_missing_list,-1,"")
    ForEach folders_sorted()
      t = folders_sorted()
      If Not x_folderexist(t)
        If uselmspaths
          t = local2serverpath(t)
        EndIf
        AddGadgetItem(#g_missing_list,-1,t)
        count = count+1
      EndIf
    Next
    If count = 0
      AddGadgetItem(#g_missing_list,-1,"None")
    EndIf
    ;
    ; 5. folders that miss files
    ;
    count = 0
    AddGadgetItem(#g_missing_list,-1,"")
    AddGadgetItem(#g_missing_list,-1,"Folders missing files")
    AddGadgetItem(#g_missing_list,-1,"")
    ForEach folders_sorted()
      t = folders_sorted()
      If x_folderexist(t)
        If uselmspaths
          t = local2serverpath(t)
        EndIf
        count = count+1
        AddGadgetItem(#g_missing_list,-1,t)
      EndIf
    Next
    If count = 0
      AddGadgetItem(#g_missing_list,-1,"None")
    EndIf
    ;
    ; 6. files missing
    ;
    count = 0
    AddGadgetItem(#g_missing_list,-1,"")
    AddGadgetItem(#g_missing_list,-1,"Missing files ("+Str(ListSize(files()))+")")
    AddGadgetItem(#g_missing_list,-1,"")
    n = 0
    ForEach files()
      t = files()
      If uselmspaths
        t = local2serverpath(t)
      EndIf
      count = count+1
      AddGadgetItem(#g_missing_list,-1,t)
      ;
      n = n+1
      SetGadgetState(#g_progress,800+200*n/ListSize(files()))
      ;
    Next
    If count = 0
      AddGadgetItem(#g_missing_list,-1,"None")
    EndIf
    ;
    AddGadgetItem(#g_missing_list,-1,"")
    If skipped = 0
      AddGadgetItem(#g_missing_list,-1,"Done")
    Else
      AddGadgetItem(#g_missing_list,-1,"Done (could not open "+Str(skipped)+" files)")
    EndIf
    SetGadgetState(#g_progress,0)
    SetGadgetState(#g_missing_led,i_led_white_h)
    DisableGadget(#g_missing_run,0)
    DisableGadget(#g_missing_copy,0)
    ;
    Repeat
      event = WaitWindowEvent(1)
    Until event = 0
    ;
  EndIf
EndProcedure

Procedure format_list()
  Protected flac.i, mp3.i, mp4.i, wma.i, ogg.i, ape.i, t4.s, t5.s, t.s, video.i, n.i
  Protected NewList folders.s()
  ;
  ; *** list all folders containing different types of music files
  ;
  fixpaths()
  If music_path > ""
    DisableGadget(#g_formats_run,1)
    SetGadgetState(#g_formats_led,i_led_red_h)
    ClearGadgetItems(#g_formats_table)
    ;
    Repeat
      event = WaitWindowEvent(1)
    Until event = 0
    ;
    x_dir(music_path,"*.*",1)
    ;
    ; strip out all non-folders
    ;
    ResetList(folders())
    ForEach x_dir_file()
      If x_dir_file()\type = #PB_DirectoryEntry_Directory
        AddElement(folders())
        folders() = music_path+x_dir_file()\name
      EndIf
    Next
    ;
    ; check each folder
    ;
    n = 0
    ForEach folders()
      ;
      n = n+1
      SetGadgetState(#g_progress,1000*n/ListSize(folders()))
      ;
      flac = 0
      mp3 = 0
      mp4 = 0
      wma = 0
      ogg = 0
      ape = 0
      x_dir(folders(),"*.*",3)
      ForEach x_dir_file()
        t4.s = Right(x_dir_file()\name,4)
        t5.s = Right(x_dir_file()\name,5)
        If t5 = ".flac"
          flac = 1
        ElseIf t4 = ".mp3"
          mp3 = 1
        ElseIf t4 = ".ogg"
          ogg = 1
        ElseIf t4 = ".ape"
          ape = 1
        ElseIf t4 = ".wma"
          wma = 1
        ElseIf t4 = ".mpg" Or t4 = ".avi" Or t4 = ".wmv" Or t4 = ".flm" Or t5 = ".mpeg"
          video = 1
        EndIf
      Next
      If (flac+mp3+ogg+ape+wma) > 1 Or video <> 0
        If uselmspaths
          folders() = local2serverpath(folders())
        EndIf
        AddGadgetItem(#g_formats_table,-1,folders())
      EndIf
    Next
    ;
    AddGadgetItem(#g_formats_table,-1,"")
    AddGadgetItem(#g_formats_table,-1,"Done")
    SetGadgetState(#g_progress,0)
    SetGadgetState(#g_formats_led,i_led_white_h)
    DisableGadget(#g_formats_run,0)
    ;
    Repeat
      event = WaitWindowEvent(1)
    Until event = 0
    ;
  EndIf
EndProcedure

Procedure information_list()
  Protected n.i, t.s
  Protected mp3.i, flac.i, ogg.i, jpg.i, bmp.i, avi.i, wma.i, wmv.i, mp4.i, mpeg.i, gif.i
  Protected t4.s, t5.s
  ;
  ; *** retrieve all sorts of information
  ;
  fixpaths()
  DisableGadget(#g_information_run,1)
  SetGadgetState(#g_information_led,i_led_red_h)
  ClearGadgetItems(#g_information_list)
  ;
  Repeat
    event = WaitWindowEvent(1)
  Until event = 0
  ;
  ; squeezebutt information
  ;
  AddGadgetItem(#g_information_list,-1,"Program")
  AddGadgetItem(#g_information_list,-1,"")
  AddGadgetItem(#g_information_list,-1,"SQB "+#sqb_version+" "+#sqb_copyright)
  AddGadgetItem(#g_information_list,-1,"Build "+#codecaddy_build_nr+" ("+FormatDate("%DD/%mm/%yy",#codecaddy_build_date)+") save "+#codecaddy_save_nr)
  AddGadgetItem(#g_information_list,-1,"Using x_lib "+#x_lib_version)
  AddGadgetItem(#g_information_list,-1,"")
  ;
  ; playlists
  ;
  AddGadgetItem(#g_information_list,-1,"Playlists")
  AddGadgetItem(#g_information_list,-1,"")
  AddGadgetItem(#g_information_list,-1,"Path: "+playlist_path)
  If music_path <> ""
    x_dir(playlist_path,"*.m3u")
    AddGadgetItem(#g_information_list,-1,Str(x_dir_n)+" .m3u files")
  EndIf
  AddGadgetItem(#g_information_list,-1,"")
  ;
  ; favorites
  ;
  AddGadgetItem(#g_information_list,-1,"Favorites")
  AddGadgetItem(#g_information_list,-1,"")
  AddGadgetItem(#g_information_list,-1,"Path: "+favorites_file)
  If x_existx(favorites_file)
    AddGadgetItem(#g_information_list,-1,"Found.")
  EndIf
  AddGadgetItem(#g_information_list,-1,"")
  ;
  ; music and related files
  ;
  AddGadgetItem(#g_information_list,-1,"Music")
  AddGadgetItem(#g_information_list,-1,"")
  AddGadgetItem(#g_information_list,-1,"Path: "+music_path)
  If music_path <> ""
    ;
    SetGadgetState(#g_progress,100)
    x_dir(music_path,"*.*")
    SetGadgetState(#g_progress,900)
    ;
    n = 0
    mp3 =0
    flac = 0
    ogg = 0
    bmp = 0
    jpg = 0
    mp4 = 0
    wma = 0
    wmv = 0
    mpeg = 0
    ResetList(x_dir_file())
    While n < x_dir_n
      n = n+1
      NextElement(x_dir_file())
      t4 = Right(x_dir_file()\name,4)
      t5 = Right(x_dir_file()\name,5)
      Select t4
          Case ".mp3"
            mp3 = mp3+1
          Case ".ogg"
            ogg = ogg+1
          Case ".wma"
            wma = wma+1
          Case ".jpg"
            jpg = jpg+1
          Case ".bmp"
            bmp = bmp+1
          Case ".wmv"
            wmv = wmv+1
          Case ".avi"
            avi = avi+1
          Case ".mp4"
            mp4 = mp4+1
          Case ".gif"
            gif = gif+1
      EndSelect
      Select t5
          Case ".flac"
            flac = flac+1
          Case ".mpeg"
            mpeg = mpeg+1
      EndSelect
    Wend
    AddGadgetItem(#g_information_list,-1,Str(x_dir_n)+" files total")
    AddGadgetItem(#g_information_list,-1,Str(mp3)+" .mp3")
    AddGadgetItem(#g_information_list,-1,Str(wma)+" .wma")
    AddGadgetItem(#g_information_list,-1,Str(ogg)+" .ogg")
    AddGadgetItem(#g_information_list,-1,Str(flac)+" .flac")
    AddGadgetItem(#g_information_list,-1,Str(jpg)+" .jpg")
    AddGadgetItem(#g_information_list,-1,Str(bmp)+" .bmp")
    AddGadgetItem(#g_information_list,-1,Str(gif)+" .gif")
    AddGadgetItem(#g_information_list,-1,Str(mpeg)+" .mpeg")
    AddGadgetItem(#g_information_list,-1,Str(avi)+" .avi")
    AddGadgetItem(#g_information_list,-1,Str(wmv)+" .wmv")
    AddGadgetItem(#g_information_list,-1,Str(mp4)+" .mp4")
    ;
    AddGadgetItem(#g_information_list,-1,"")
    AddGadgetItem(#g_information_list,-1,"Operation")
    AddGadgetItem(#g_information_list,-1,"")
    AddGadgetItem(#g_information_list,-1,Str(skipped)+" fails to open a file")
  EndIf
  ;
  ; done
  ;
  AddGadgetItem(#g_information_list,-1,"")
  AddGadgetItem(#g_information_list,-1,"Done")
  SetGadgetState(#g_progress,0)
  SetGadgetState(#g_information_led,i_led_white_h)
  DisableGadget(#g_information_run,0)
  ;
  Repeat
    event = WaitWindowEvent(1)
  Until event = 0
  ;
EndProcedure

Procedure replace_run(file.s="")
  Protected playlist.s, t.s, old.s, check.s, new.s, n.i, nn.i, x.s, aa.s, bb.s, found.i, missing.i, stripped.i, lines.i, modified.i, ab_n.i
  Protected Dim a.s(1000)
  Protected Dim b.s(1000)
  ;
  ; *** process all playlists and replace paths / names according to instructions
  ;
  ; in: file.s = ""           - process all
  ;     file.s = <filename>   - process only that file
  ;
  ; approach:
  ;
  ; 0. process replacement table for speedup
  ; 1. process specific, or go through all playlists
  ; 2. process each line
  ; 3. strip # and #missing
  ; 4. modify entry according to instructions
  ; 5. check if new one exists
  ; 6. if not, mark as missing
  ;
  ;
  ; 0. process replacement table
  ;
  fixpaths()
  n = CountString(replacelist,#CRLF$)
  nn = 0
  ab_n = 0
  While nn < n And ab_n < 1000
    nn = nn+1
    x = StringField(replacelist,nn,#CRLF$)
    If CountString(x," > ") = 1                                        ; check if there is a '>' character
      aa = Trim(StringField(x,1,">"))
      bb = Trim(StringField(x,2,">"))
      If aa > "" And bb > ""                                           ; check if there are two parts left and right of '>'
        ab_n = ab_n+1
        a(ab_n) = aa
        b(ab_n) = bb
      EndIf
    EndIf
  Wend
  ;
  SetGadgetState(#g_progress,100)
  ;
  If music_path > "" And playlist_path > "" And ab_n > 0
    ;
    ; 1. process specific file, or go through all playlists
    ;
    found = 0
    missing = 0
    stripped = 0
    lines = 0
    modified = 0
    ;
    If file > ""
      x_dir(playlist_path,file,2,0)                                      ; get one playlist
    Else
      x_dir(playlist_path,"*.m3u",2,0)                                   ; get all playlists
    EndIf
    ;
    n = 0
    ResetList(x_dir_file())
    ForEach x_dir_file()                                                 ; process all playlists
      t = x_dir_file()\name                                              ; read playlist name
      ;
      n = n+1
      SetGadgetState(#g_progress,200+(800*n/x_dir_n))                    ; update progress gadget
      ;
      ; create a backup file
      ; use the backup file as source, overwrite the original file
      ;
      x_excopyfile(1,t,2,t+".bak")
      If x_exreadfile(1,t+".bak",#PB_UTF8) = 0                               ; use backup file as source
        skipped = skipped+1
        Debug Str(#PB_Compiler_Line)+" could not open "+t+".bak, "+Str(skipped)+" skipped"
      Else
        ReadStringFormat(1)                                              ; strip eventual bom
        If forceascii = #True
          x_excreatefile(2,t,#PB_Ascii)                                      ; create a file, doesn't add bom
        Else
          x_excreateFile(2,t,#PB_UTF8)                                       ; create utf8 file, adds bom
          WriteStringFormat(2,#PB_UTF8)
        EndIf
        ;
        ; 2. process each line
        ; 3. strip # and #MISSING
        ;
        While Not Eof(1)
          old = Trim(ReadString(1))
          lines = lines+1
          If Left(old,8) = "#MISSING"                                    ; remove the #MISSING tag to allow re-check of the line
            old = Mid(old,10,512)
          EndIf
          If Left(old,1) = "#" Or old = ""                               ; remove any remaining comments and empty lines
            stripped = stripped+1
          Else
            ;
            ; 4. modify entry according to replace instructions
            ;
            new = old
            nn = 0
            While nn < ab_n
              nn = nn+1
              new = ReplaceString(new,a(nn),b(nn),#PB_String_NoCase)
            Wend
            ;
            ; 5. check if the new path+file exists
            ; 6. if not, mark as missing
            ;
            check = server2localpath(new)                                ; change the path so the file can be seen from the client
            If x_exist(check)
              found = found+1                                            ; file has been found, increase found counter
              If old <> new
                modified = modified+1                                    ; entry has been modified, increase counter
              EndIf
            Else                                                         ; file was not found, increase missing counter
              missing = missing+1
              If replacecheck                                            ; file was not found, do not modify, keep old entry
                new = "#MISSING "+old
              Else                                                       ; file was not found, keep eventual modification
                If old <> new
                  modified = modified+1                                  ; increase modification counter
                EndIf
                new = "#MISSING "+new
              EndIf
            EndIf
            If forceascii = #True
              WriteString(2,new+#CRLF$,#PB_Ascii)
            Else
              WriteString(2,new+#CRLF$,#PB_UTF8)
            EndIf
          EndIf
        Wend
        CloseFile(1)
        CloseFile(2)
        ;
      EndIf
    Next
    ;
    SetGadgetState(#g_progress,1000)
    ;
    If warnings
      t = "Processed "+Str(x_dir_n)+" playlists."
      t = t+#CRLF$+"Total lines: "+Str(lines)
      t = t+#CRLF$+"Lines stripped: "+Str(stripped)
      t = t+#CRLF$+"Lines modified: "+Str(modified)
      t = t+#CRLF$+"Files found: "+Str(found)
      t = t+#CRLF$+"Marked as missing: "+Str(missing)
      MessageRequester("Replace results",t,#PB_MessageRequester_Ok)
    EndIf
    ;
  EndIf
  ;
  SetGadgetState(#g_progress,0)
  ;
EndProcedure

Procedure replace_point()
  Protected x.s, p.i, t.s, f.s, n.i
  ;
  ; *** create a replace rule
  ;
  x = Trim(GetGadgetItemText(#g_replace_list,replacelist_row))
  If x > ""
    n = FindString(x,">")
    If n > 0
      x = Trim(Left(x,n-1))
    EndIf
    ;
    If pointremember = #False
      replacepoint_path = music_path
    EndIf
    If FindString(replacepoint_path,music_path,1,#PB_String_NoCase) <= 0                     ; protection against invalid replacepoint_path values
      replacepoint_path = music_path
    EndIf
    If Right(replacepoint_path,1) = "\" And Len(replacepoint_path) > 3
      replacepoint_path = GetPathPart(replacepoint_path)
    EndIf
    ;
    t = GetFilePart(x)
    f = OpenFileRequester(t,replacepoint_path,"*.*|*.*",0)
    If f > ""
      replacepoint_path = GetPathPart(f)
      f = local2serverpath(f)
      x = "  "+x+"   >   "+f
      SetGadgetItemText(#g_replace_list,replacelist_row,x)
    EndIf
    ;
  EndIf
  ;
EndProcedure

Procedure main()
  Protected t.s, n.i, r.i, selection_start.i, selection_end.i
  Protected newpaneltab.i, oldpaneltab.i
  ;
  ; *** open primary window
  ;
  ExamineDesktops()
  w_main_width = x_max(w_main_width,DesktopWidth(0)*8/10)
  w_main_height = x_max(w_main_height,DesktopHeight(0)*7/10)
  ;
  OpenWindow(#w_main_nr,10,30,w_main_width,w_main_height,#sqb_name+" "+#sqb_version+" - "+#sqb_copyright,#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget)
  WindowBounds(#w_main_nr,1010,490,#PB_Ignore,#PB_Ignore)
  draw()
  setuserfields()
  ;
  ;
  ; *** event loop
  ;
  Repeat
    action = #f_none
    refresh = #False
    event = WaitWindowEvent()
    event_menu = EventMenu()
    event_type = EventType()
    event_gadget = EventGadget()
    ;
    ; get_userfields()
    ;
    ; three stage approach:
    ;
    ; 1. process the event, then either take action immediately, or redirect to stage two by setting the action variable
    ; 2. take action, depending on the action.i variable
    ; 3. do any required screen updates if refresh.i has been set to true
    ;
    ;
    ; *** stage 1: detect and handle events
    ;
    Select event
        Case #WM_KEYUP, #WM_LBUTTONUP
          ;
          ; unfortunately purebasic doesn't have a native way to detect where the cursor in an editorgadget, but this works also
          ; (needed for the replacelist, to allow user to manually point to some missing music file)
          ;
          If GetActiveGadget() = #g_replace_list
            SendMessage_(GadgetID(#g_replace_list), #EM_GETSEL, @selection_start, @selection_end)
            replacelist_row = SendMessage_(GadgetID(#g_replace_list), #EM_LINEFROMCHAR, selection_start, 0)
          EndIf
          ;
        Case #WM_LBUTTONDBLCLK
          ;
          ; double click in the replace window
          ;
          If GetActiveGadget() = #g_replace_list
            replace_point()
          EndIf
          ;
        Case #PB_Event_SizeWindow
          ;
          ; this is a kludge, once all is done add a resize procedure to resize all gadgets whilst retaining content
          ;
          oldpaneltab = GetGadgetState(#g_panel_main)
          draw()
          setuserfields()
          SetGadgetState(#g_panel_main,oldpaneltab)
          If oldpaneltab = #g_panel_folder
            folder_list()
          ElseIf oldpaneltab = #g_panel_playlist
            playlist_list()
          EndIf
          ;
        Case #PB_Event_CloseWindow
          ;
          action = #f_exit
          ;
        Case #PB_Event_Menu
          ;
          action = event_menu
          ;
        Case #PB_Event_Gadget
          ;
          Select event_gadget
                ;
              Case #g_panel_main
                ;
                ; auto refresh panel on tab change
                ;
                newpaneltab = GetGadgetState(#g_panel_main)
                If reload
                  If newpaneltab <> oldpaneltab
                    oldpaneltab = newpaneltab
                    If newpaneltab = #g_panel_playlist
                      playlist_list()
                    ElseIf newpaneltab = #g_panel_folder
                      folder_list()
                    EndIf
                  EndIf
                EndIf
                ;
              Case #g_prefs_music_path
                ;
                ; set music path, manual entry
                ;
                music_path = x_validpathname(GetGadgetText(#g_prefs_music_path))
                ;
              Case #g_prefs_music_browse
                ;
                ; set music path, browse button
                ;
                If x_folderexist(music_path)
                Else
                  music_path = ""
                EndIf
                t = x_validpathname(PathRequester("Select path to music files",music_path))
                If x_folderexist(t)
                  music_path = t
                  SetGadgetText(#g_prefs_music_path,music_path)
                EndIf
                ;
              Case #g_prefs_music_explore
                ;
                ; explore playlist path
                ;
                explorefolder(music_path)
                ;
              Case #g_prefs_playlist_path
                ;
                ; set playlist path, manual entry
                ;
                playlist_path = x_validpathname(GetGadgetText(#g_prefs_playlist_path))
                ;
              Case #g_prefs_playlist_browse
                ;
                ; set playlists path, browse button
                ;
                If x_folderexist(playlist_path)
                Else
                  playlist_path = ""
                EndIf
                t = x_validpathname(PathRequester("Select path to playlists",playlist_path))
                If x_folderexist(t)
                  playlist_path = t
                  SetGadgetText(#g_prefs_playlist_path,playlist_path)
                EndIf
                ;
              Case #g_prefs_playlist_explore
                ;
                ; explore playlist path
                ;
                explorefolder(playlist_path)
                ;
              Case #g_prefs_favorites_browse
                ;
                ; set favorites file, browse button
                ;
                If x_existx(favorites_file)
                Else
                  favorites_file = ""
                EndIf
                t = OpenFileRequester("Select favorites.oml file",favorites_file,"*.opml|*.opml|*.*|*.*",0)
                If x_existx(t)
                  favorites_file = t
                  SetGadgetText(#g_prefs_favorites_file,favorites_file)
                EndIf
                ;
              Case #g_prefs_runningonserver_toggle
                ;
                ; run on server checkbox
                ;
                runningonserver = GetGadgetState(#g_prefs_runningonserver_toggle)
                updateordisable()
                ;
              Case #g_prefs_uselmspaths_toggle
                ;
                ; use lmspaths checkbox
                ;
                uselmspaths = GetGadgetState(#g_prefs_uselmspaths_toggle)
                updateordisable()
                ;
              Case #g_prefs_refresh_toggle
                ;
                ; refresh on resize or tab change
                ;
                reload = GetGadgetState(#g_prefs_refresh_toggle)
                updateordisable()
                ;
              Case #g_prefs_server_path
                ;
                ; set server path (local path for LMS), manual entry, no browse possible
                ;
                server_path = x_validpathname(GetGadgetText(#g_prefs_server_path))
                ;
              Case #g_prefs_forceascii_toggle
                ;
                ; forceascii checkbox
                ;
                forceascii = GetGadgetState(#g_prefs_forceascii_toggle)
                ;
              Case #g_prefs_warnings_toggle
                ;
                ; warnings toggle
                ;
                warnings = GetGadgetState(#g_prefs_warnings_toggle)
                ;
              Case #g_prefs_quircklevel_combo
                ;
                ; change of quircks level
                ;
                quircklevel = Val(GetGadgetText(#g_prefs_quircklevel_combo))
                ;
              Case #g_prefs_explorerlaunch_path
                ;
                ; set explorer, manual entry in string gadget
                ;
                explorerlaunch_file = GetGadgetText(#g_prefs_explorerlaunch_path)
                ;
              Case #g_prefs_explorerlaunch_browse
                ;
                ; set explorer, browse button
                ;
                If x_exist(explorerlaunch_file)
                Else
                  explorerlaunch_file = GetPathPart(ProgramFilename())
                EndIf
                t = OpenFileRequester("Select file browser",explorerlaunch_file,"*.exe|*.exe",0)
                If x_exist(t)
                  explorerlaunch_file = t
                  SetGadgetText(#g_prefs_explorerlaunch_path,explorerlaunch_file)
                EndIf
                ;
              Case #g_prefs_editorlaunch_path
                ;
                ; set editor, manual edit
                ;
                editorlaunch_file = GetGadgetText(#g_prefs_editorlaunch_path)
                ;
              Case #g_prefs_editorlaunch_browse
                ;
                ; set editor, browse button
                ;
                If x_exist(editorlaunch_file)
                Else
                  editorlaunch_file = GetPathPart(ProgramFilename())
                EndIf
                t = OpenFileRequester("Select file browser",editorlaunch_file,"*.exe|*.exe",0)
                If x_exist(t)
                  editorlaunch_file = t
                  SetGadgetText(#g_prefs_editorlaunch_path,editorlaunch_file)
                EndIf
                ;
              Case #g_prefs_help
                ;
                ; show help and license
                ;
                CloseWindow(#w_main_nr)
                x_littlehelp(" SQB "+#sqb_version+" - "+#sqb_copyright+" - "+FormatDate("%DD.%MM.%YYYY",#codecaddy_build_date)+" build "+Str(#codecaddy_build_nr)+" save "+Str(#codecaddy_save_nr),"",p_helptext,#PB_Ascii)
                OpenWindow(#w_main_nr,10,30,w_main_width,w_main_height,#sqb_name+" "+#sqb_version,#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget)
                WindowBounds(#w_main_nr,800,490,#PB_Ignore,#PB_Ignore)
                draw()
                setuserfields()
                ;
              Case #g_prefs_save
                ;
                ; save settings (NOT automatically done when closing)
                ;
                savesettings()
                ;
              Case #g_prefs_load
                ;
                ; load settings (automatically done when starting)
                ;
                loadsettings()
                setuserfields()
                ;
              Case #g_prefs_exportasmp3_toggle
                ;
                ; convert .flac to .mp3
                ;
                exportasmp3 = GetGadgetState(#g_prefs_exportasmp3_toggle)
                ;
              Case #g_prefs_exe_path
                ;
                ; where to find sox.exe
                ;
                sox_file = GetGadgetText(#g_prefs_exe_path)
                ;
              Case #g_prefs_exe_browse
                ;
                ; point to sox.exe
                ;
                If x_exist(sox_file)
                Else
                  sox_file = GetPathPart(ProgramFilename())
                EndIf
                t = OpenFileRequester("Select sox.exe",sox_file,"sox.exe|sox.exe",0)
                If x_exist(t)
                  sox_file = t
                  SetGadgetText(#g_prefs_exe_path,sox_file)
                EndIf
                ;
              Case #g_prefs_hidesox_toggle
                ;
                ; hide sox window
                ;
                hidesox = GetGadgetState(#g_prefs_hidesox_toggle)
                ;
              Case #g_prefs_jobsmax_combo
                ;
                ; number of conversion instances
                ;
                jobsmax = GetGadgetState(#g_prefs_jobsmax_combo)+1
                ;
                ;
              Case #g_prefs_bitrate_combo
                ;
                ; set bitrate of exported mp3
                ;
                mp3bitrate = GetGadgetText(#g_prefs_bitrate_combo)
                ;
              Case #g_prefs_quality_combo
                ;
                ; set conversion quality when converting .flac to .mp3
                ;
                conversionquality = Val(GetGadgetText(#g_prefs_quality_combo))
                ;
              Case #g_prefs_export_path
                ;
                ; where to place exported .mp3 files
                ;
                export_path = GetGadgetText(#g_prefs_export_path)
                ;
              Case #g_prefs_export_browse
                ;
                ; point to export folder
                ;
                If x_exist(export_path)
                Else
                  export_path = GetPathPart(ProgramFilename())
                EndIf
                t = PathRequester("Select export path",export_path)
                If x_folderexist(t)
                  export_path = t
                  SetGadgetText(#g_prefs_export_path,export_path)
                EndIf
                ;
              Case #g_prefs_exportfolders_toggle
                ;
                ; create folders based on filename + path of original file
                ;
                exportfolders = GetGadgetState(#g_prefs_exportfolders_toggle)
                ;
              Case #g_prefs_exportnumbers_toggle
                ;
                ; add a number in front of the filename of the exported file
                ;
                exportnumber = GetGadgetState(#g_prefs_exportnumbers_toggle)
                ;
              Case #g_prefs_exportoverwrite_toggle
                ;
                ; overwrite existing files
                ;
                exportoverwrite = GetGadgetState(#g_prefs_exportoverwrite_toggle)
                ;
              Case #g_prefs_exportusetemp_toggle
                ;
                ; use a local temporary file for conversion .flac to .mp3
                ;
                exportusetemp = GetGadgetState(#g_prefs_exportusetemp_toggle)
                ;
              Case #g_prefs_exportprefix_toggle
                ;
                ; string to place in front of foldernames of exported playlists
                ;
                exportprefix = GetGadgetState(#g_prefs_exportprefix_toggle)
                ;
              Case #g_folder_read
                ;
                ; list all folders
                ;
                folder_list()
                ;
              Case #g_folder_explore
                ;
                ; explore first marked folder
                ;
                If GetGadgetState(#g_folder_table) > 0
                  t = music_path+GetGadgetItemText(#g_folder_table,GetGadgetState(#g_folder_table))
                  If x_folderexist(t)
                    explorefolder(t)
                  EndIf
                EndIf
                ;
              Case #g_folder_export
                ;
                ; export folder
                ;
                folder_export()
                ;
              Case #g_playlist_table
                ;
                ; doubleclick will open editor with selected file
                ;
                If event_type = #PB_EventType_LeftDoubleClick
                  t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                  editfile(t)
                EndIf
                ;
              Case #g_playlist_explore
                ;
                ; browse playlist folder
                ;
                explorefolder(playlist_path)
                ;
              Case #g_playlist_read
                ;
                ; re-populate playlist list
                ;
                playlist_list()
                ;
              Case #g_playlist_edit
                ;
                If GetGadgetState(#g_playlist_table) > -1
                  t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                  editfile(t)
                EndIf
                ;
              Case #g_playlist_strip
                ;
                ; strip all non-essential information from the playlist
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If warnings = #True
                    r = MessageRequester("Strip playlist","Remove all lines beginning with # except for #MISSING."+#CRLF$+#CRLF$+"Continue?",#PB_MessageRequester_YesNo)
                  Else
                    r = #PB_MessageRequester_Yes
                  EndIf
                  If r = #PB_MessageRequester_Yes
                    playlist_strip(t)
                  EndIf
                EndIf
                ;
              Case #g_playlist_sort
                ;
                ; strip all # comments except for #MISSING, then sort the list
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If warnings = #True
                    r = MessageRequester("Sort playlist","Remove all # lines except #MISSING, then sort the playlist."+#CRLF$+#CRLF$+"Continue?",#PB_MessageRequester_YesNo)
                  Else
                    r = #PB_MessageRequester_Yes
                  EndIf
                  If r = #PB_MessageRequester_Yes
                    playlist_sort(t)
                  EndIf
                EndIf
                ;
              Case #g_playlist_shuffle
                ;
                ; strip all # comments except for #missing, then sort, then shuffle with maximal dispersion
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If warnings = #True
                    r = MessageRequester("Shuffle playlist","Remove all # lines except #MISSING, then sort and shuffle the playlist."+#CRLF$+#CRLF$+"Continue?",#PB_MessageRequester_YesNo)
                  Else
                    r = #PB_MessageRequester_Yes
                  EndIf
                  If r = #PB_MessageRequester_Yes
                    playlist_shuffle(t)
                    editfile(t)
                  EndIf
                EndIf
                ;
              Case #g_playlist_mix
                ;
                ; create new interleaved playlist by combining two other shuffled playlists
                ;
                If warnings = #True
                  r = MessageRequester("Mix playlists","Create new interleaved / shuffled playlist based on two existing playlists."+#CRLF$+#CRLF$+"Pick two source files, then a destination file. Continue?",#PB_MessageRequester_YesNo)
                EndIf
                If r = #PB_MessageRequester_Yes
                  playlist_mix()
                  playlist_list()
                EndIf
                ;
              Case #g_playlist_mark
                ;
                ; strip playlist and mark any missing files using the #MISSING tag
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If warnings = #True
                    r = MessageRequester("Mark playlist","Remove all # lines and mark all missing files with #MISSING."+#CRLF$+#CRLF$+"Continue?",#PB_MessageRequester_YesNo)
                  Else
                    r = #PB_MessageRequester_Yes
                  EndIf
                  If r = #PB_MessageRequester_Yes
                    playlist_mark(t)
                  EndIf
                EndIf
                ;
              Case #g_playlist_dedupe
                ;
                ; remove duplicates, sort entries, mark missing files
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If warnings = #True
                    r = MessageRequester("De-duplicate playlist","Remove comments, remove duplicates, sort, mark #MISSING."+#CRLF$+#CRLF$+"Continue?",#PB_MessageRequester_YesNo)
                  Else
                    r = #PB_MessageRequester_Yes
                  EndIf
                  If r = #PB_MessageRequester_Yes
                    playlist_deduplicate(t)
                  EndIf
                EndIf
                ;
              Case #g_playlist_replace
                ;
                ; process specific playlist using rules given on replace tab
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If warnings = #True
                    r = MessageRequester("Replace playlist","Modify the selected playlist using the replacement table."+#CRLF$+#CRLF$+"Continue?",#PB_MessageRequester_YesNo)
                  Else
                    r = #PB_MessageRequester_Yes
                  EndIf
                  If r = #PB_MessageRequester_Yes
                    replace_run(GetFilePart(t))
                    editfile(t)
                  EndIf
                EndIf
                ;
              Case #g_playlist_export
                ;
                ; export all files refered to in the playlist, convert if needed
                ;
                t = playlist_path+GetGadgetItemText(#g_playlist_table,GetGadgetState(#g_playlist_table))
                If x_exist(t)
                  If x_exist(sox_file)
                    If x_validpathname(export_path) > ""
                      If Not x_folderexist(export_path)
                        CreateDirectory(export_path)
                      EndIf
                      If x_folderexist(export_path)
                        playlist_export(t)
                      EndIf
                    EndIf
                  EndIf
                EndIf
                ;
              Case #g_missing_uselmspaths_toggle
                ;
                ; use lmspaths checkbox
                ;
                uselmspaths = GetGadgetState(#g_missing_uselmspaths_toggle)
                updateordisable()
                ;
              Case #g_missing_run
                ;
                ; list all missing files and folders
                ;
                playlists_scan()
                ;
              Case #g_missing_copy
                ;
                ; set replacement table and switch to replace tab
                ;
                ; SetClipboardText(GetGadgetText(#g_missing_list))
                SetGadgetText(#g_replace_list,GetGadgetText(#g_missing_list))
                SetGadgetState(#g_panel_main,#g_panel_replace)
                ;
              Case #g_formats_table
                ;
                ; doubleclick will open explorer in the selected folder
                ;
                If event_type = #PB_EventType_LeftDoubleClick
                  t = GetGadgetItemText(#g_formats_table,GetGadgetState(#g_formats_table))
                  If uselmspaths
                    t = server2localpath(t)
                  EndIf
                  explorefolder(t)
                EndIf
                ;
              Case #g_formats_run
                ;
                ; list all folders that contain .flac files and any other type of music file
                ;
                format_list()
                ;
              Case #g_replace_list
                ;
                ; get instructions for replace function
                ;
                SendMessage_(GadgetID(#g_replace_list), #EM_GETSEL, @selection_start, @selection_end)
                replacelist_row = SendMessage_(GadgetID(#g_replace_list), #EM_LINEFROMCHAR, selection_start, 0)
                replacelist = GetGadgetText(#g_replace_list)
                ;
              Case #g_replace_existcheck_toggle
                ;
                ; only modify playlist entry if it points to an existing file
                ;
                replacecheck = GetGadgetState(#g_replace_existcheck_toggle)
                ;
              Case #g_replace_pointremember_toggle
                ;
                ; always start point action from music folder
                ;
                pointremember = GetGadgetState(#g_replace_pointremember_toggle)
                ;
              Case #g_replace_clear
                ;
                ; clear replace list
                ;
                ClearGadgetItems(#g_replace_list)
                replacelist = GetGadgetText(#g_replace_list)
                ;
              Case #g_replace_point
                ;
                replace_point()
                ;
              Case #g_replace_apply
                ;
                ; process all playlists and replace strings as defined in the replacement table
                ;
                If warnings = #True
                  r = MessageRequester("Replace in ALL playlists","Modify ALL playlists using the replacement table."+#CRLF$+#CRLF$+"Are you sure?",#PB_MessageRequester_YesNo)
                Else
                  r = #PB_MessageRequester_Yes
                EndIf
                If r = #PB_MessageRequester_Yes
                  replace_run()
                EndIf
                ;
              Case #g_replace_applyplus
                ;
                ; rescan, then fill the replace list with scan results
                ;
                If warnings = #True
                  r = MessageRequester("Replace and rescan","Modify ALL playlists, then rescan and copy results."+#CRLF$+#CRLF$+"Are you sure?",#PB_MessageRequester_YesNo)
                Else
                  r = #PB_MessageRequester_Yes
                EndIf
                If r = #PB_MessageRequester_Yes
                  replace_run()
                  playlists_scan()
                  replacelist = GetGadgetText(#g_missing_list)
                  SetGadgetText(#g_replace_list,replacelist)
                EndIf
                ;
              Case #g_information_run
                ;
                ; request program and status information
                ;
                information_list()
                ;
          EndSelect
          ;
    EndSelect
    ;
    ;
    ; *** stage 2: take action, if required
    ;
    Select action
        Case #f_exit
          ;
          ; exit
          ;
        Case #f_point
          ;
          ; alt+p was pressed
          ;
          If GetActiveGadget() = #g_replace_list
            replace_point()
          EndIf
          ;
        Case #f_none
          ;
          ; none
          ;
    EndSelect
    ;
    ;
    ; *** stage 3: some activity may have required a redraw
    ;
    If refresh = #True
      ;
      ; <-- insert any screen updates here
      ;
      refresh = #False
    EndIf
    ;
  Until action = #f_exit
  ;
EndProcedure

; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 397
; Folding = AAAAw
; Markers = 1222
; EnableAsm
; EnableXP
; UseIcon = icons\sqb.ico
; Executable = sqb.exe
; CompileSourceDirectory